# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20221109

module OCI
  module AiDocument
    # Module containing models for requests made to, and responses received from,
    # OCI AiDocument services
    module Models
    end
  end
end

# Require models
require 'oci/ai_document/models/action_type'
require 'oci/ai_document/models/analyze_document_details'
require 'oci/ai_document/models/analyze_document_result'
require 'oci/ai_document/models/bounding_polygon'
require 'oci/ai_document/models/cell'
require 'oci/ai_document/models/change_model_compartment_details'
require 'oci/ai_document/models/change_project_compartment_details'
require 'oci/ai_document/models/component_model'
require 'oci/ai_document/models/create_model_details'
require 'oci/ai_document/models/create_processor_job_details'
require 'oci/ai_document/models/create_project_details'
require 'oci/ai_document/models/data_science_labeling_dataset'
require 'oci/ai_document/models/dataset'
require 'oci/ai_document/models/dataset_summary'
require 'oci/ai_document/models/detected_document_type'
require 'oci/ai_document/models/detected_language'
require 'oci/ai_document/models/dimensions'
require 'oci/ai_document/models/document_classification_confidence_entry'
require 'oci/ai_document/models/document_classification_feature'
require 'oci/ai_document/models/document_classification_label_metrics_report'
require 'oci/ai_document/models/document_classification_model_metrics'
require 'oci/ai_document/models/document_classification_overall_metrics_report'
require 'oci/ai_document/models/document_details'
require 'oci/ai_document/models/document_feature'
require 'oci/ai_document/models/document_field'
require 'oci/ai_document/models/document_key_value_extraction_feature'
require 'oci/ai_document/models/document_language_classification_feature'
require 'oci/ai_document/models/document_metadata'
require 'oci/ai_document/models/document_table_extraction_feature'
require 'oci/ai_document/models/document_text_extraction_feature'
require 'oci/ai_document/models/document_type'
require 'oci/ai_document/models/field_label'
require 'oci/ai_document/models/field_name'
require 'oci/ai_document/models/field_value'
require 'oci/ai_document/models/general_processor_config'
require 'oci/ai_document/models/inline_document_content'
require 'oci/ai_document/models/inline_document_details'
require 'oci/ai_document/models/input_location'
require 'oci/ai_document/models/key_value_detection_confidence_entry'
require 'oci/ai_document/models/key_value_detection_label_metrics_report'
require 'oci/ai_document/models/key_value_detection_model_metrics'
require 'oci/ai_document/models/key_value_detection_overall_metrics_report'
require 'oci/ai_document/models/line'
require 'oci/ai_document/models/model'
require 'oci/ai_document/models/model_collection'
require 'oci/ai_document/models/model_metrics'
require 'oci/ai_document/models/model_summary'
require 'oci/ai_document/models/normalized_vertex'
require 'oci/ai_document/models/object_location'
require 'oci/ai_document/models/object_storage_dataset'
require 'oci/ai_document/models/object_storage_document_details'
require 'oci/ai_document/models/object_storage_locations'
require 'oci/ai_document/models/operation_status'
require 'oci/ai_document/models/operation_type'
require 'oci/ai_document/models/output_location'
require 'oci/ai_document/models/page'
require 'oci/ai_document/models/patch_model_details'
require 'oci/ai_document/models/patch_model_operation'
require 'oci/ai_document/models/patch_response_message'
require 'oci/ai_document/models/processing_error'
require 'oci/ai_document/models/processor_config'
require 'oci/ai_document/models/processor_job'
require 'oci/ai_document/models/processor_type'
require 'oci/ai_document/models/project'
require 'oci/ai_document/models/project_collection'
require 'oci/ai_document/models/project_summary'
require 'oci/ai_document/models/sort_order'
require 'oci/ai_document/models/table'
require 'oci/ai_document/models/table_row'
require 'oci/ai_document/models/update_model_details'
require 'oci/ai_document/models/update_project_details'
require 'oci/ai_document/models/value_array'
require 'oci/ai_document/models/value_date'
require 'oci/ai_document/models/value_integer'
require 'oci/ai_document/models/value_number'
require 'oci/ai_document/models/value_phone_number'
require 'oci/ai_document/models/value_string'
require 'oci/ai_document/models/value_time'
require 'oci/ai_document/models/word'
require 'oci/ai_document/models/work_request'
require 'oci/ai_document/models/work_request_error'
require 'oci/ai_document/models/work_request_error_collection'
require 'oci/ai_document/models/work_request_log_entry'
require 'oci/ai_document/models/work_request_log_entry_collection'
require 'oci/ai_document/models/work_request_resource'
require 'oci/ai_document/models/work_request_resource_metadata_key'
require 'oci/ai_document/models/work_request_summary'
require 'oci/ai_document/models/work_request_summary_collection'

# Require generated clients
require 'oci/ai_document/ai_service_document_client'
require 'oci/ai_document/ai_service_document_client_composite_operations'

# Require service utilities
require 'oci/ai_document/util'
