# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20221001

module OCI
  module AiLanguage
    # Module containing models for requests made to, and responses received from,
    # OCI AiLanguage services
    module Models
    end
  end
end

# Require models
require 'oci/ai_language/models/action_type'
require 'oci/ai_language/models/assertion_details'
require 'oci/ai_language/models/batch_detect_dominant_language_details'
require 'oci/ai_language/models/batch_detect_dominant_language_result'
require 'oci/ai_language/models/batch_detect_health_entity_details'
require 'oci/ai_language/models/batch_detect_health_entity_result'
require 'oci/ai_language/models/batch_detect_language_entities_details'
require 'oci/ai_language/models/batch_detect_language_entities_result'
require 'oci/ai_language/models/batch_detect_language_key_phrases_details'
require 'oci/ai_language/models/batch_detect_language_key_phrases_result'
require 'oci/ai_language/models/batch_detect_language_pii_entities_details'
require 'oci/ai_language/models/batch_detect_language_pii_entities_result'
require 'oci/ai_language/models/batch_detect_language_sentiments_details'
require 'oci/ai_language/models/batch_detect_language_sentiments_result'
require 'oci/ai_language/models/batch_detect_language_text_classification_details'
require 'oci/ai_language/models/batch_detect_language_text_classification_result'
require 'oci/ai_language/models/batch_language_translation_details'
require 'oci/ai_language/models/batch_language_translation_result'
require 'oci/ai_language/models/capabilities'
require 'oci/ai_language/models/capability'
require 'oci/ai_language/models/change_endpoint_compartment_details'
require 'oci/ai_language/models/change_job_compartment_details'
require 'oci/ai_language/models/change_model_compartment_details'
require 'oci/ai_language/models/change_project_compartment_details'
require 'oci/ai_language/models/class_metrics'
require 'oci/ai_language/models/classification_multi_class_mode_details'
require 'oci/ai_language/models/classification_multi_label_mode_details'
require 'oci/ai_language/models/classification_type'
require 'oci/ai_language/models/configuration_details'
require 'oci/ai_language/models/confusion_matrix_details'
require 'oci/ai_language/models/create_endpoint_details'
require 'oci/ai_language/models/create_job_details'
require 'oci/ai_language/models/create_model_details'
require 'oci/ai_language/models/create_project_details'
require 'oci/ai_language/models/data_science_labeling_dataset'
require 'oci/ai_language/models/dataset_details'
require 'oci/ai_language/models/detect_dominant_language_details'
require 'oci/ai_language/models/detect_dominant_language_result'
require 'oci/ai_language/models/detect_language_entities_details'
require 'oci/ai_language/models/detect_language_entities_result'
require 'oci/ai_language/models/detect_language_key_phrases_details'
require 'oci/ai_language/models/detect_language_key_phrases_result'
require 'oci/ai_language/models/detect_language_sentiments_details'
require 'oci/ai_language/models/detect_language_sentiments_result'
require 'oci/ai_language/models/detect_language_text_classification_details'
require 'oci/ai_language/models/detect_language_text_classification_result'
require 'oci/ai_language/models/detected_language'
require 'oci/ai_language/models/document_error'
require 'oci/ai_language/models/documents_configuration'
require 'oci/ai_language/models/dominant_language_document'
require 'oci/ai_language/models/dominant_language_document_result'
require 'oci/ai_language/models/endpoint'
require 'oci/ai_language/models/endpoint_collection'
require 'oci/ai_language/models/endpoint_summary'
require 'oci/ai_language/models/entity'
require 'oci/ai_language/models/entity_document_result'
require 'oci/ai_language/models/entity_label_error_analysis'
require 'oci/ai_language/models/entity_metrics'
require 'oci/ai_language/models/error_details'
require 'oci/ai_language/models/evaluation_result_collection'
require 'oci/ai_language/models/evaluation_result_summary'
require 'oci/ai_language/models/evaluation_results'
require 'oci/ai_language/models/health_entity'
require 'oci/ai_language/models/health_entity_document_result'
require 'oci/ai_language/models/hierarchical_entity'
require 'oci/ai_language/models/input_configuration'
require 'oci/ai_language/models/input_location'
require 'oci/ai_language/models/job'
require 'oci/ai_language/models/job_collection'
require 'oci/ai_language/models/job_summary'
require 'oci/ai_language/models/key_phrase'
require 'oci/ai_language/models/key_phrase_document_result'
require 'oci/ai_language/models/location_details'
require 'oci/ai_language/models/mel_concept'
require 'oci/ai_language/models/mel_concept_details'
require 'oci/ai_language/models/model'
require 'oci/ai_language/models/model_collection'
require 'oci/ai_language/models/model_details'
require 'oci/ai_language/models/model_metadata_details'
require 'oci/ai_language/models/model_summary'
require 'oci/ai_language/models/model_type_info'
require 'oci/ai_language/models/named_entity_recognition_evaluation_result'
require 'oci/ai_language/models/named_entity_recognition_evaluation_results'
require 'oci/ai_language/models/named_entity_recognition_model_details'
require 'oci/ai_language/models/named_entity_recognition_model_metrics'
require 'oci/ai_language/models/ner_model_version'
require 'oci/ai_language/models/object_list_dataset'
require 'oci/ai_language/models/object_prefix_output_location'
require 'oci/ai_language/models/object_storage_dataset'
require 'oci/ai_language/models/object_storage_file_name_location'
require 'oci/ai_language/models/object_storage_prefix_location'
require 'oci/ai_language/models/operation_status'
require 'oci/ai_language/models/operation_type'
require 'oci/ai_language/models/pii_entity'
require 'oci/ai_language/models/pii_entity_document_result'
require 'oci/ai_language/models/pii_entity_mask'
require 'oci/ai_language/models/pii_entity_masking'
require 'oci/ai_language/models/pii_entity_remove'
require 'oci/ai_language/models/pii_entity_replace'
require 'oci/ai_language/models/pii_model_details'
require 'oci/ai_language/models/pre_deployed_language_models'
require 'oci/ai_language/models/pre_trained_health_nlu_model_details'
require 'oci/ai_language/models/pre_trained_key_phrase_extraction_model_details'
require 'oci/ai_language/models/pre_trained_language_detection_model_details'
require 'oci/ai_language/models/pre_trained_named_entity_recognition_model_details'
require 'oci/ai_language/models/pre_trained_pii_model_details'
require 'oci/ai_language/models/pre_trained_sentiment_analysis_model_details'
require 'oci/ai_language/models/pre_trained_summarization'
require 'oci/ai_language/models/pre_trained_text_classification_model_details'
require 'oci/ai_language/models/pre_trained_universal_model'
require 'oci/ai_language/models/profile'
require 'oci/ai_language/models/project'
require 'oci/ai_language/models/project_collection'
require 'oci/ai_language/models/project_summary'
require 'oci/ai_language/models/relation_entity'
require 'oci/ai_language/models/resolved_entities'
require 'oci/ai_language/models/resolved_entity'
require 'oci/ai_language/models/sentiment_aspect'
require 'oci/ai_language/models/sentiment_document_result'
require 'oci/ai_language/models/sentiment_sentence'
require 'oci/ai_language/models/sort_order'
require 'oci/ai_language/models/test_and_validation_dataset_strategy'
require 'oci/ai_language/models/test_strategy'
require 'oci/ai_language/models/text_classification'
require 'oci/ai_language/models/text_classification_document_result'
require 'oci/ai_language/models/text_classification_evaluation_results'
require 'oci/ai_language/models/text_classification_model_details'
require 'oci/ai_language/models/text_classification_model_evaluation_result'
require 'oci/ai_language/models/text_classification_model_metrics'
require 'oci/ai_language/models/text_document'
require 'oci/ai_language/models/translation_document_result'
require 'oci/ai_language/models/update_endpoint_details'
require 'oci/ai_language/models/update_job_details'
require 'oci/ai_language/models/update_model_details'
require 'oci/ai_language/models/update_project_details'
require 'oci/ai_language/models/work_request'
require 'oci/ai_language/models/work_request_error'
require 'oci/ai_language/models/work_request_error_collection'
require 'oci/ai_language/models/work_request_log'
require 'oci/ai_language/models/work_request_log_collection'
require 'oci/ai_language/models/work_request_resource'
require 'oci/ai_language/models/work_request_summary'
require 'oci/ai_language/models/work_request_summary_collection'

# Require generated clients
require 'oci/ai_language/ai_service_language_client'
require 'oci/ai_language/ai_service_language_client_composite_operations'

# Require service utilities
require 'oci/ai_language/util'
