# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220125

module OCI
  module AiVision
    # Module containing models for requests made to, and responses received from,
    # OCI AiVision services
    module Models
    end
  end
end

# Require models
require 'oci/ai_vision/models/action_type'
require 'oci/ai_vision/models/analyze_document_details'
require 'oci/ai_vision/models/analyze_document_result'
require 'oci/ai_vision/models/analyze_image_details'
require 'oci/ai_vision/models/analyze_image_result'
require 'oci/ai_vision/models/bounding_polygon'
require 'oci/ai_vision/models/cell'
require 'oci/ai_vision/models/change_model_compartment_details'
require 'oci/ai_vision/models/change_project_compartment_details'
require 'oci/ai_vision/models/create_document_job_details'
require 'oci/ai_vision/models/create_image_job_details'
require 'oci/ai_vision/models/create_model_details'
require 'oci/ai_vision/models/create_project_details'
require 'oci/ai_vision/models/data_science_labeling_dataset'
require 'oci/ai_vision/models/dataset'
require 'oci/ai_vision/models/detected_document_type'
require 'oci/ai_vision/models/detected_language'
require 'oci/ai_vision/models/dimensions'
require 'oci/ai_vision/models/document_classification_feature'
require 'oci/ai_vision/models/document_details'
require 'oci/ai_vision/models/document_feature'
require 'oci/ai_vision/models/document_field'
require 'oci/ai_vision/models/document_job'
require 'oci/ai_vision/models/document_key_value_detection_feature'
require 'oci/ai_vision/models/document_language'
require 'oci/ai_vision/models/document_language_classification_feature'
require 'oci/ai_vision/models/document_metadata'
require 'oci/ai_vision/models/document_table_detection_feature'
require 'oci/ai_vision/models/document_text_detection_feature'
require 'oci/ai_vision/models/document_type'
require 'oci/ai_vision/models/face'
require 'oci/ai_vision/models/face_detection_feature'
require 'oci/ai_vision/models/field_label'
require 'oci/ai_vision/models/field_name'
require 'oci/ai_vision/models/field_value'
require 'oci/ai_vision/models/image_classification_feature'
require 'oci/ai_vision/models/image_details'
require 'oci/ai_vision/models/image_feature'
require 'oci/ai_vision/models/image_job'
require 'oci/ai_vision/models/image_object'
require 'oci/ai_vision/models/image_object_detection_feature'
require 'oci/ai_vision/models/image_text'
require 'oci/ai_vision/models/image_text_detection_feature'
require 'oci/ai_vision/models/inline_document_details'
require 'oci/ai_vision/models/inline_image_details'
require 'oci/ai_vision/models/input_location'
require 'oci/ai_vision/models/label'
require 'oci/ai_vision/models/landmark'
require 'oci/ai_vision/models/line'
require 'oci/ai_vision/models/model'
require 'oci/ai_vision/models/model_collection'
require 'oci/ai_vision/models/model_summary'
require 'oci/ai_vision/models/normalized_vertex'
require 'oci/ai_vision/models/object_list_inline_input_location'
require 'oci/ai_vision/models/object_location'
require 'oci/ai_vision/models/object_storage_dataset'
require 'oci/ai_vision/models/object_storage_document_details'
require 'oci/ai_vision/models/object_storage_image_details'
require 'oci/ai_vision/models/ontology_class'
require 'oci/ai_vision/models/operation_status'
require 'oci/ai_vision/models/operation_type'
require 'oci/ai_vision/models/output_location'
require 'oci/ai_vision/models/page'
require 'oci/ai_vision/models/processing_error'
require 'oci/ai_vision/models/project'
require 'oci/ai_vision/models/project_collection'
require 'oci/ai_vision/models/project_summary'
require 'oci/ai_vision/models/sort_order'
require 'oci/ai_vision/models/table'
require 'oci/ai_vision/models/table_row'
require 'oci/ai_vision/models/update_model_details'
require 'oci/ai_vision/models/update_project_details'
require 'oci/ai_vision/models/value_array'
require 'oci/ai_vision/models/value_date'
require 'oci/ai_vision/models/value_integer'
require 'oci/ai_vision/models/value_number'
require 'oci/ai_vision/models/value_phone_number'
require 'oci/ai_vision/models/value_string'
require 'oci/ai_vision/models/value_time'
require 'oci/ai_vision/models/word'
require 'oci/ai_vision/models/work_request'
require 'oci/ai_vision/models/work_request_error'
require 'oci/ai_vision/models/work_request_error_collection'
require 'oci/ai_vision/models/work_request_log_entry'
require 'oci/ai_vision/models/work_request_log_entry_collection'
require 'oci/ai_vision/models/work_request_resource'
require 'oci/ai_vision/models/work_request_summary'
require 'oci/ai_vision/models/work_request_summary_collection'

# Require generated clients
require 'oci/ai_vision/ai_service_vision_client'
require 'oci/ai_vision/ai_service_vision_client_composite_operations'

# Require service utilities
require 'oci/ai_vision/util'
