# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200630

module OCI
  module ApmSynthetics
    # Module containing models for requests made to, and responses received from,
    # OCI ApmSynthetics services
    module Models
    end
  end
end

# Require models
require 'oci/apm_synthetics/models/aggregate_network_data_details'
require 'oci/apm_synthetics/models/aggregated_network_data'
require 'oci/apm_synthetics/models/aggregated_network_data_result'
require 'oci/apm_synthetics/models/availability_configuration'
require 'oci/apm_synthetics/models/available_capability'
require 'oci/apm_synthetics/models/browser_monitor_configuration'
require 'oci/apm_synthetics/models/client_certificate'
require 'oci/apm_synthetics/models/client_certificate_details'
require 'oci/apm_synthetics/models/content_types'
require 'oci/apm_synthetics/models/create_dedicated_vantage_point_details'
require 'oci/apm_synthetics/models/create_monitor_details'
require 'oci/apm_synthetics/models/create_on_premise_vantage_point_details'
require 'oci/apm_synthetics/models/create_script_details'
require 'oci/apm_synthetics/models/create_worker_details'
require 'oci/apm_synthetics/models/dedicated_vantage_point'
require 'oci/apm_synthetics/models/dedicated_vantage_point_collection'
require 'oci/apm_synthetics/models/dedicated_vantage_point_status'
require 'oci/apm_synthetics/models/dedicated_vantage_point_summary'
require 'oci/apm_synthetics/models/dns_configuration'
require 'oci/apm_synthetics/models/dns_record_type'
require 'oci/apm_synthetics/models/dns_sec_monitor_configuration'
require 'oci/apm_synthetics/models/dns_server_monitor_configuration'
require 'oci/apm_synthetics/models/dns_trace_monitor_configuration'
require 'oci/apm_synthetics/models/dns_transport_protocol'
require 'oci/apm_synthetics/models/dvp_stack_details'
require 'oci/apm_synthetics/models/geo_summary'
require 'oci/apm_synthetics/models/header'
require 'oci/apm_synthetics/models/identity_info_details'
require 'oci/apm_synthetics/models/link'
require 'oci/apm_synthetics/models/maintenance_window_schedule'
require 'oci/apm_synthetics/models/monitor'
require 'oci/apm_synthetics/models/monitor_collection'
require 'oci/apm_synthetics/models/monitor_configuration'
require 'oci/apm_synthetics/models/monitor_result'
require 'oci/apm_synthetics/models/monitor_result_data'
require 'oci/apm_synthetics/models/monitor_script_parameter'
require 'oci/apm_synthetics/models/monitor_script_parameter_info'
require 'oci/apm_synthetics/models/monitor_status'
require 'oci/apm_synthetics/models/monitor_status_count_map'
require 'oci/apm_synthetics/models/monitor_summary'
require 'oci/apm_synthetics/models/monitor_types'
require 'oci/apm_synthetics/models/network_configuration'
require 'oci/apm_synthetics/models/network_monitor_configuration'
require 'oci/apm_synthetics/models/node'
require 'oci/apm_synthetics/models/o_auth_schemes'
require 'oci/apm_synthetics/models/on_premise_vantage_point'
require 'oci/apm_synthetics/models/on_premise_vantage_point_collection'
require 'oci/apm_synthetics/models/on_premise_vantage_point_summary'
require 'oci/apm_synthetics/models/on_premise_vantage_point_worker_status'
require 'oci/apm_synthetics/models/on_premise_vantage_point_worker_type'
require 'oci/apm_synthetics/models/on_premise_vp_worker_version_details'
require 'oci/apm_synthetics/models/oracle_rm_stack'
require 'oci/apm_synthetics/models/private_key'
require 'oci/apm_synthetics/models/probe_mode'
require 'oci/apm_synthetics/models/protocol'
require 'oci/apm_synthetics/models/public_vantage_point_collection'
require 'oci/apm_synthetics/models/public_vantage_point_summary'
require 'oci/apm_synthetics/models/request_authentication_details'
require 'oci/apm_synthetics/models/request_authentication_schemes'
require 'oci/apm_synthetics/models/request_authentication_schemes_for_scripted_rest'
require 'oci/apm_synthetics/models/request_methods'
require 'oci/apm_synthetics/models/request_query_param'
require 'oci/apm_synthetics/models/rest_monitor_configuration'
require 'oci/apm_synthetics/models/scheduling_policy'
require 'oci/apm_synthetics/models/script'
require 'oci/apm_synthetics/models/script_collection'
require 'oci/apm_synthetics/models/script_parameter'
require 'oci/apm_synthetics/models/script_parameter_info'
require 'oci/apm_synthetics/models/script_summary'
require 'oci/apm_synthetics/models/scripted_browser_monitor_configuration'
require 'oci/apm_synthetics/models/scripted_rest_monitor_configuration'
require 'oci/apm_synthetics/models/sort_orders'
require 'oci/apm_synthetics/models/update_dedicated_vantage_point_details'
require 'oci/apm_synthetics/models/update_monitor_details'
require 'oci/apm_synthetics/models/update_on_premise_vantage_point_details'
require 'oci/apm_synthetics/models/update_script_details'
require 'oci/apm_synthetics/models/update_worker_details'
require 'oci/apm_synthetics/models/vantage_point_execution'
require 'oci/apm_synthetics/models/vantage_point_info'
require 'oci/apm_synthetics/models/vantage_point_node'
require 'oci/apm_synthetics/models/verify_text'
require 'oci/apm_synthetics/models/worker'
require 'oci/apm_synthetics/models/worker_collection'
require 'oci/apm_synthetics/models/worker_monitor_list'
require 'oci/apm_synthetics/models/worker_summary'
require 'oci/apm_synthetics/models/workers_summary'

# Require generated clients
require 'oci/apm_synthetics/apm_synthetic_client'

# Require service utilities
require 'oci/apm_synthetics/util'
