# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200630

module OCI
  module ApmTraces
    # Module containing models for requests made to, and responses received from,
    # OCI ApmTraces services
    module Models
    end
  end
end

# Require models
require 'oci/apm_traces/models/aggregated_snapshot'
require 'oci/apm_traces/models/aggregated_stack_trace'
require 'oci/apm_traces/models/attribute_pin_response'
require 'oci/apm_traces/models/attribute_response'
require 'oci/apm_traces/models/attribute_unpin_response'
require 'oci/apm_traces/models/attribute_update_notes_response'
require 'oci/apm_traces/models/attribute_update_response'
require 'oci/apm_traces/models/auto_activate_status'
require 'oci/apm_traces/models/auto_activate_toggle_status'
require 'oci/apm_traces/models/bulk_activate_attribute_detail'
require 'oci/apm_traces/models/bulk_activate_attribute_details'
require 'oci/apm_traces/models/bulk_activation_metadata'
require 'oci/apm_traces/models/bulk_activation_status'
require 'oci/apm_traces/models/bulk_de_activate_attribute_detail'
require 'oci/apm_traces/models/bulk_de_activate_attribute_details'
require 'oci/apm_traces/models/bulk_de_activation_metadata'
require 'oci/apm_traces/models/bulk_de_activation_status'
require 'oci/apm_traces/models/bulk_pin_attribute_detail'
require 'oci/apm_traces/models/bulk_pin_attribute_details'
require 'oci/apm_traces/models/bulk_pin_metadata'
require 'oci/apm_traces/models/bulk_pin_status'
require 'oci/apm_traces/models/bulk_unpin_attribute_detail'
require 'oci/apm_traces/models/bulk_unpin_attribute_details'
require 'oci/apm_traces/models/bulk_unpin_metadata'
require 'oci/apm_traces/models/bulk_unpin_status'
require 'oci/apm_traces/models/bulk_update_attribute_detail'
require 'oci/apm_traces/models/bulk_update_attribute_details'
require 'oci/apm_traces/models/bulk_update_attribute_metadata'
require 'oci/apm_traces/models/bulk_update_attribute_notes_detail'
require 'oci/apm_traces/models/bulk_update_attribute_notes_details'
require 'oci/apm_traces/models/bulk_update_attribute_status'
require 'oci/apm_traces/models/bulk_update_notes_metadata'
require 'oci/apm_traces/models/bulk_update_notes_status'
require 'oci/apm_traces/models/query_details'
require 'oci/apm_traces/models/query_result_metadata_summary'
require 'oci/apm_traces/models/query_result_response'
require 'oci/apm_traces/models/query_result_row'
require 'oci/apm_traces/models/query_result_row_type_summary'
require 'oci/apm_traces/models/query_result_warning'
require 'oci/apm_traces/models/query_results_grouped_by_summary'
require 'oci/apm_traces/models/query_results_ordered_by_summary'
require 'oci/apm_traces/models/query_results_topology_info'
require 'oci/apm_traces/models/query_results_topology_node_info'
require 'oci/apm_traces/models/quick_pick_summary'
require 'oci/apm_traces/models/snapshot_detail'
require 'oci/apm_traces/models/span'
require 'oci/apm_traces/models/span_log'
require 'oci/apm_traces/models/span_log_collection'
require 'oci/apm_traces/models/span_snapshot'
require 'oci/apm_traces/models/stack_trace_element'
require 'oci/apm_traces/models/tag'
require 'oci/apm_traces/models/tag_metadata'
require 'oci/apm_traces/models/thread_snapshot'
require 'oci/apm_traces/models/trace'
require 'oci/apm_traces/models/trace_service_summary'
require 'oci/apm_traces/models/trace_snapshot'
require 'oci/apm_traces/models/trace_span_summary'

# Require generated clients
require 'oci/apm_traces/attributes_client'
require 'oci/apm_traces/query_client'
require 'oci/apm_traces/trace_client'

# Require service utilities
require 'oci/apm_traces/util'
