# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20190531
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # The request body when creating BDS metastore configuration.
  class Bds::Models::CreateBdsMetastoreConfigurationDetails
    # The display name of the metastore configuration
    # @return [String]
    attr_accessor :display_name

    # **[Required]** The OCID of the Data Catalog metastore.
    # @return [String]
    attr_accessor :metastore_id

    # **[Required]** The ID of BDS Api Key used for Data Catalog metastore integration.
    # @return [String]
    attr_accessor :bds_api_key_id

    # **[Required]** Base-64 encoded passphrase of the BDS Api Key.
    # @return [String]
    attr_accessor :bds_api_key_passphrase

    # **[Required]** Base-64 encoded password for the cluster admin user.
    # @return [String]
    attr_accessor :cluster_admin_password

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'display_name': :'displayName',
        'metastore_id': :'metastoreId',
        'bds_api_key_id': :'bdsApiKeyId',
        'bds_api_key_passphrase': :'bdsApiKeyPassphrase',
        'cluster_admin_password': :'clusterAdminPassword'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'display_name': :'String',
        'metastore_id': :'String',
        'bds_api_key_id': :'String',
        'bds_api_key_passphrase': :'String',
        'cluster_admin_password': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :display_name The value to assign to the {#display_name} property
    # @option attributes [String] :metastore_id The value to assign to the {#metastore_id} property
    # @option attributes [String] :bds_api_key_id The value to assign to the {#bds_api_key_id} property
    # @option attributes [String] :bds_api_key_passphrase The value to assign to the {#bds_api_key_passphrase} property
    # @option attributes [String] :cluster_admin_password The value to assign to the {#cluster_admin_password} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.display_name = attributes[:'displayName'] if attributes[:'displayName']

      raise 'You cannot provide both :displayName and :display_name' if attributes.key?(:'displayName') && attributes.key?(:'display_name')

      self.display_name = attributes[:'display_name'] if attributes[:'display_name']

      self.metastore_id = attributes[:'metastoreId'] if attributes[:'metastoreId']

      raise 'You cannot provide both :metastoreId and :metastore_id' if attributes.key?(:'metastoreId') && attributes.key?(:'metastore_id')

      self.metastore_id = attributes[:'metastore_id'] if attributes[:'metastore_id']

      self.bds_api_key_id = attributes[:'bdsApiKeyId'] if attributes[:'bdsApiKeyId']

      raise 'You cannot provide both :bdsApiKeyId and :bds_api_key_id' if attributes.key?(:'bdsApiKeyId') && attributes.key?(:'bds_api_key_id')

      self.bds_api_key_id = attributes[:'bds_api_key_id'] if attributes[:'bds_api_key_id']

      self.bds_api_key_passphrase = attributes[:'bdsApiKeyPassphrase'] if attributes[:'bdsApiKeyPassphrase']

      raise 'You cannot provide both :bdsApiKeyPassphrase and :bds_api_key_passphrase' if attributes.key?(:'bdsApiKeyPassphrase') && attributes.key?(:'bds_api_key_passphrase')

      self.bds_api_key_passphrase = attributes[:'bds_api_key_passphrase'] if attributes[:'bds_api_key_passphrase']

      self.cluster_admin_password = attributes[:'clusterAdminPassword'] if attributes[:'clusterAdminPassword']

      raise 'You cannot provide both :clusterAdminPassword and :cluster_admin_password' if attributes.key?(:'clusterAdminPassword') && attributes.key?(:'cluster_admin_password')

      self.cluster_admin_password = attributes[:'cluster_admin_password'] if attributes[:'cluster_admin_password']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        display_name == other.display_name &&
        metastore_id == other.metastore_id &&
        bds_api_key_id == other.bds_api_key_id &&
        bds_api_key_passphrase == other.bds_api_key_passphrase &&
        cluster_admin_password == other.cluster_admin_password
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [display_name, metastore_id, bds_api_key_id, bds_api_key_passphrase, cluster_admin_password].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
