# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200129

module OCI
  module DataFlow
    # Module containing models for requests made to, and responses received from,
    # OCI DataFlow services
    module Models
    end
  end
end

# Require models
require 'oci/data_flow/models/application'
require 'oci/data_flow/models/application_language'
require 'oci/data_flow/models/application_lifecycle_state'
require 'oci/data_flow/models/application_log_config'
require 'oci/data_flow/models/application_parameter'
require 'oci/data_flow/models/application_summary'
require 'oci/data_flow/models/application_type'
require 'oci/data_flow/models/change_application_compartment_details'
require 'oci/data_flow/models/change_pool_compartment_details'
require 'oci/data_flow/models/change_private_endpoint_compartment_details'
require 'oci/data_flow/models/change_run_compartment_details'
require 'oci/data_flow/models/change_sql_endpoint_compartment_details'
require 'oci/data_flow/models/create_application_details'
require 'oci/data_flow/models/create_pool_details'
require 'oci/data_flow/models/create_private_endpoint_details'
require 'oci/data_flow/models/create_run_details'
require 'oci/data_flow/models/create_sql_endpoint_details'
require 'oci/data_flow/models/create_statement_details'
require 'oci/data_flow/models/day_of_week'
require 'oci/data_flow/models/image_png_statement_output_data'
require 'oci/data_flow/models/ip_notation_type'
require 'oci/data_flow/models/network_type'
require 'oci/data_flow/models/node_count'
require 'oci/data_flow/models/pool'
require 'oci/data_flow/models/pool_collection'
require 'oci/data_flow/models/pool_config'
require 'oci/data_flow/models/pool_lifecycle_state'
require 'oci/data_flow/models/pool_metrics'
require 'oci/data_flow/models/pool_schedule'
require 'oci/data_flow/models/pool_summary'
require 'oci/data_flow/models/private_endpoint'
require 'oci/data_flow/models/private_endpoint_collection'
require 'oci/data_flow/models/private_endpoint_lifecycle_state'
require 'oci/data_flow/models/private_endpoint_summary'
require 'oci/data_flow/models/run'
require 'oci/data_flow/models/run_lifecycle_state'
require 'oci/data_flow/models/run_log_summary'
require 'oci/data_flow/models/run_summary'
require 'oci/data_flow/models/scan'
require 'oci/data_flow/models/secure_access_control_rule'
require 'oci/data_flow/models/shape_config'
require 'oci/data_flow/models/sql_endpoint'
require 'oci/data_flow/models/sql_endpoint_collection'
require 'oci/data_flow/models/sql_endpoint_lifecycle_state'
require 'oci/data_flow/models/sql_endpoint_network_configuration'
require 'oci/data_flow/models/sql_endpoint_secure_access_config'
require 'oci/data_flow/models/sql_endpoint_summary'
require 'oci/data_flow/models/sql_endpoint_vcn_config'
require 'oci/data_flow/models/statement'
require 'oci/data_flow/models/statement_collection'
require 'oci/data_flow/models/statement_lifecycle_state'
require 'oci/data_flow/models/statement_output'
require 'oci/data_flow/models/statement_output_data'
require 'oci/data_flow/models/statement_summary'
require 'oci/data_flow/models/text_html_statement_output_data'
require 'oci/data_flow/models/text_plain_statement_output_data'
require 'oci/data_flow/models/update_application_details'
require 'oci/data_flow/models/update_pool_details'
require 'oci/data_flow/models/update_private_endpoint_details'
require 'oci/data_flow/models/update_run_details'
require 'oci/data_flow/models/update_sql_endpoint_details'
require 'oci/data_flow/models/work_request'
require 'oci/data_flow/models/work_request_collection'
require 'oci/data_flow/models/work_request_error'
require 'oci/data_flow/models/work_request_error_collection'
require 'oci/data_flow/models/work_request_log'
require 'oci/data_flow/models/work_request_log_collection'
require 'oci/data_flow/models/work_request_operation'
require 'oci/data_flow/models/work_request_resource'
require 'oci/data_flow/models/work_request_status'
require 'oci/data_flow/models/work_request_summary'

# Require generated clients
require 'oci/data_flow/data_flow_client'
require 'oci/data_flow/data_flow_client_composite_operations'

# Require service utilities
require 'oci/data_flow/util'
