# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20201101

module OCI
  module DatabaseManagement
    # Module containing models for requests made to, and responses received from,
    # OCI DatabaseManagement services
    module Models
    end
  end
end

# Require models
require 'oci/database_management/models/activity_time_series_metrics'
require 'oci/database_management/models/add_data_files_details'
require 'oci/database_management/models/add_managed_database_to_managed_database_group_details'
require 'oci/database_management/models/addm_task_summary'
require 'oci/database_management/models/addm_tasks_collection'
require 'oci/database_management/models/advisor_rule'
require 'oci/database_management/models/alert_log_collection'
require 'oci/database_management/models/alert_log_count_summary'
require 'oci/database_management/models/alert_log_counts_collection'
require 'oci/database_management/models/alert_log_summary'
require 'oci/database_management/models/alert_severity_enum'
require 'oci/database_management/models/alert_type_enum'
require 'oci/database_management/models/allowed_parameter_value'
require 'oci/database_management/models/asm_connection_credentails_by_name'
require 'oci/database_management/models/asm_connection_credentials'
require 'oci/database_management/models/asm_connection_credentials_by_details'
require 'oci/database_management/models/asm_connection_string'
require 'oci/database_management/models/asm_property'
require 'oci/database_management/models/asm_property_collection'
require 'oci/database_management/models/asm_property_summary'
require 'oci/database_management/models/associated_component'
require 'oci/database_management/models/associated_database_collection'
require 'oci/database_management/models/associated_database_summary'
require 'oci/database_management/models/associated_service_details'
require 'oci/database_management/models/attention_log_collection'
require 'oci/database_management/models/attention_log_count_summary'
require 'oci/database_management/models/attention_log_counts_collection'
require 'oci/database_management/models/attention_log_summary'
require 'oci/database_management/models/automatic_capture_filter'
require 'oci/database_management/models/automatic_capture_filter_details'
require 'oci/database_management/models/awr_db_collection'
require 'oci/database_management/models/awr_db_cpu_usage_collection'
require 'oci/database_management/models/awr_db_cpu_usage_summary'
require 'oci/database_management/models/awr_db_metric_collection'
require 'oci/database_management/models/awr_db_metric_summary'
require 'oci/database_management/models/awr_db_parameter_change_collection'
require 'oci/database_management/models/awr_db_parameter_change_summary'
require 'oci/database_management/models/awr_db_parameter_collection'
require 'oci/database_management/models/awr_db_parameter_summary'
require 'oci/database_management/models/awr_db_report'
require 'oci/database_management/models/awr_db_snapshot_collection'
require 'oci/database_management/models/awr_db_snapshot_range_collection'
require 'oci/database_management/models/awr_db_snapshot_range_summary'
require 'oci/database_management/models/awr_db_snapshot_summary'
require 'oci/database_management/models/awr_db_sql_report'
require 'oci/database_management/models/awr_db_summary'
require 'oci/database_management/models/awr_db_sysstat_collection'
require 'oci/database_management/models/awr_db_sysstat_summary'
require 'oci/database_management/models/awr_db_top_wait_event_collection'
require 'oci/database_management/models/awr_db_top_wait_event_summary'
require 'oci/database_management/models/awr_db_wait_event_bucket_collection'
require 'oci/database_management/models/awr_db_wait_event_bucket_summary'
require 'oci/database_management/models/awr_db_wait_event_collection'
require 'oci/database_management/models/awr_db_wait_event_summary'
require 'oci/database_management/models/awr_query_result'
require 'oci/database_management/models/basic_database_connection_string_details'
require 'oci/database_management/models/basic_named_credential_content'
require 'oci/database_management/models/basic_preferred_credential'
require 'oci/database_management/models/change_database_parameter_details'
require 'oci/database_management/models/change_database_parameters_details'
require 'oci/database_management/models/change_db_management_private_endpoint_compartment_details'
require 'oci/database_management/models/change_external_db_system_compartment_details'
require 'oci/database_management/models/change_external_exadata_infrastructure_compartment_details'
require 'oci/database_management/models/change_job_compartment_details'
require 'oci/database_management/models/change_managed_database_group_compartment_details'
require 'oci/database_management/models/change_named_credential_compartment_details'
require 'oci/database_management/models/change_plan_retention_details'
require 'oci/database_management/models/change_space_budget_details'
require 'oci/database_management/models/change_sql_plan_baselines_attributes_details'
require 'oci/database_management/models/child_database'
require 'oci/database_management/models/clone_sql_tuning_task_details'
require 'oci/database_management/models/cluster_cache_metric'
require 'oci/database_management/models/compare_type'
require 'oci/database_management/models/configure_automatic_capture_filters_details'
require 'oci/database_management/models/configure_automatic_spm_evolve_advisor_task_details'
require 'oci/database_management/models/connector_details'
require 'oci/database_management/models/consumer_group_privilege_collection'
require 'oci/database_management/models/consumer_group_privilege_summary'
require 'oci/database_management/models/cpu_utilization_aggregate_metrics'
require 'oci/database_management/models/create_db_management_private_endpoint_details'
require 'oci/database_management/models/create_external_db_system_connector_details'
require 'oci/database_management/models/create_external_db_system_details'
require 'oci/database_management/models/create_external_db_system_discovery_details'
require 'oci/database_management/models/create_external_db_system_macs_connector_details'
require 'oci/database_management/models/create_external_exadata_infrastructure_details'
require 'oci/database_management/models/create_external_exadata_storage_connector_details'
require 'oci/database_management/models/create_job_details'
require 'oci/database_management/models/create_managed_database_group_details'
require 'oci/database_management/models/create_named_credential_details'
require 'oci/database_management/models/create_sql_job_details'
require 'oci/database_management/models/create_sql_tuning_set_details'
require 'oci/database_management/models/create_tablespace_details'
require 'oci/database_management/models/cursor_cache_statement_collection'
require 'oci/database_management/models/cursor_cache_statement_summary'
require 'oci/database_management/models/data_access_container_collection'
require 'oci/database_management/models/data_access_container_summary'
require 'oci/database_management/models/database_connection_credentails_by_name'
require 'oci/database_management/models/database_connection_credentials'
require 'oci/database_management/models/database_connection_credentials_by_details'
require 'oci/database_management/models/database_connection_details'
require 'oci/database_management/models/database_connection_string'
require 'oci/database_management/models/database_connection_string_details'
require 'oci/database_management/models/database_credential_details'
require 'oci/database_management/models/database_credentials'
require 'oci/database_management/models/database_diagnostics_and_management_feature_configuration'
require 'oci/database_management/models/database_diagnostics_and_management_feature_details'
require 'oci/database_management/models/database_feature_configuration'
require 'oci/database_management/models/database_feature_details'
require 'oci/database_management/models/database_fleet_health_metrics'
require 'oci/database_management/models/database_home_metric_definition'
require 'oci/database_management/models/database_home_metrics'
require 'oci/database_management/models/database_io_aggregate_metrics'
require 'oci/database_management/models/database_instance_home_metrics_definition'
require 'oci/database_management/models/database_management_config'
require 'oci/database_management/models/database_named_credential_details'
require 'oci/database_management/models/database_parameter_summary'
require 'oci/database_management/models/database_parameter_update_status'
require 'oci/database_management/models/database_parameters_collection'
require 'oci/database_management/models/database_password_credential_details'
require 'oci/database_management/models/database_plan'
require 'oci/database_management/models/database_plan_directive'
require 'oci/database_management/models/database_plan_role_enum'
require 'oci/database_management/models/database_plan_type_enum'
require 'oci/database_management/models/database_secret_credential_details'
require 'oci/database_management/models/database_ssl_connection_credentials'
require 'oci/database_management/models/database_status'
require 'oci/database_management/models/database_storage_aggregate_metrics'
require 'oci/database_management/models/database_sub_type'
require 'oci/database_management/models/database_time_aggregate_metrics'
require 'oci/database_management/models/database_type'
require 'oci/database_management/models/database_usage_metrics'
require 'oci/database_management/models/datafile'
require 'oci/database_management/models/db_management_analytics_metric'
require 'oci/database_management/models/db_management_feature'
require 'oci/database_management/models/db_management_private_endpoint'
require 'oci/database_management/models/db_management_private_endpoint_collection'
require 'oci/database_management/models/db_management_private_endpoint_summary'
require 'oci/database_management/models/dbm_resource'
require 'oci/database_management/models/deployment_type'
require 'oci/database_management/models/disable_automatic_initial_plan_capture_details'
require 'oci/database_management/models/disable_automatic_spm_evolve_advisor_task_details'
require 'oci/database_management/models/disable_database_management_feature_details'
require 'oci/database_management/models/disable_external_container_database_management_feature_details'
require 'oci/database_management/models/disable_external_non_container_database_management_feature_details'
require 'oci/database_management/models/disable_external_pluggable_database_management_feature_details'
require 'oci/database_management/models/disable_high_frequency_automatic_spm_evolve_advisor_task_details'
require 'oci/database_management/models/disable_pluggable_database_management_feature_details'
require 'oci/database_management/models/disable_sql_plan_baselines_usage_details'
require 'oci/database_management/models/discover_external_exadata_infrastructure_details'
require 'oci/database_management/models/discovered_external_asm'
require 'oci/database_management/models/discovered_external_asm_instance'
require 'oci/database_management/models/discovered_external_cluster'
require 'oci/database_management/models/discovered_external_cluster_instance'
require 'oci/database_management/models/discovered_external_database'
require 'oci/database_management/models/discovered_external_db_home'
require 'oci/database_management/models/discovered_external_db_node'
require 'oci/database_management/models/discovered_external_db_system_component'
require 'oci/database_management/models/discovered_external_listener'
require 'oci/database_management/models/discovered_external_pluggable_database'
require 'oci/database_management/models/drop_sql_plan_baselines_details'
require 'oci/database_management/models/drop_sql_tuning_set_details'
require 'oci/database_management/models/drop_sql_tuning_task_details'
require 'oci/database_management/models/drop_sqls_in_sql_tuning_set_details'
require 'oci/database_management/models/drop_tablespace_details'
require 'oci/database_management/models/enable_automatic_initial_plan_capture_details'
require 'oci/database_management/models/enable_automatic_spm_evolve_advisor_task_details'
require 'oci/database_management/models/enable_database_management_feature_details'
require 'oci/database_management/models/enable_external_container_database_management_feature_details'
require 'oci/database_management/models/enable_external_db_system_database_management_details'
require 'oci/database_management/models/enable_external_db_system_stack_monitoring_details'
require 'oci/database_management/models/enable_external_exadata_infrastructure_management_details'
require 'oci/database_management/models/enable_external_non_container_database_management_feature_details'
require 'oci/database_management/models/enable_external_pluggable_database_management_feature_details'
require 'oci/database_management/models/enable_high_frequency_automatic_spm_evolve_advisor_task_details'
require 'oci/database_management/models/enable_pluggable_database_management_feature_details'
require 'oci/database_management/models/enable_sql_plan_baselines_usage_details'
require 'oci/database_management/models/entity_discovered'
require 'oci/database_management/models/execution_plan_stats_comparision'
require 'oci/database_management/models/external_asm'
require 'oci/database_management/models/external_asm_collection'
require 'oci/database_management/models/external_asm_configuration'
require 'oci/database_management/models/external_asm_connection_info'
require 'oci/database_management/models/external_asm_disk_group_collection'
require 'oci/database_management/models/external_asm_disk_group_summary'
require 'oci/database_management/models/external_asm_instance'
require 'oci/database_management/models/external_asm_instance_collection'
require 'oci/database_management/models/external_asm_instance_parameters'
require 'oci/database_management/models/external_asm_instance_summary'
require 'oci/database_management/models/external_asm_serviced_database'
require 'oci/database_management/models/external_asm_summary'
require 'oci/database_management/models/external_asm_user_collection'
require 'oci/database_management/models/external_asm_user_summary'
require 'oci/database_management/models/external_cluster'
require 'oci/database_management/models/external_cluster_collection'
require 'oci/database_management/models/external_cluster_instance'
require 'oci/database_management/models/external_cluster_instance_collection'
require 'oci/database_management/models/external_cluster_instance_summary'
require 'oci/database_management/models/external_cluster_network_configuration'
require 'oci/database_management/models/external_cluster_scan_listener_configuration'
require 'oci/database_management/models/external_cluster_summary'
require 'oci/database_management/models/external_cluster_vip_configuration'
require 'oci/database_management/models/external_connector_details'
require 'oci/database_management/models/external_database_collection'
require 'oci/database_management/models/external_database_connection_info'
require 'oci/database_management/models/external_database_diagnostics_and_management_feature_details'
require 'oci/database_management/models/external_database_feature_details'
require 'oci/database_management/models/external_database_instance'
require 'oci/database_management/models/external_database_summary'
require 'oci/database_management/models/external_database_system_discovery_summary'
require 'oci/database_management/models/external_db_home'
require 'oci/database_management/models/external_db_home_collection'
require 'oci/database_management/models/external_db_home_summary'
require 'oci/database_management/models/external_db_node'
require 'oci/database_management/models/external_db_node_collection'
require 'oci/database_management/models/external_db_node_summary'
require 'oci/database_management/models/external_db_system'
require 'oci/database_management/models/external_db_system_basic_info'
require 'oci/database_management/models/external_db_system_collection'
require 'oci/database_management/models/external_db_system_component_type'
require 'oci/database_management/models/external_db_system_connection_info'
require 'oci/database_management/models/external_db_system_connector'
require 'oci/database_management/models/external_db_system_connector_collection'
require 'oci/database_management/models/external_db_system_connector_summary'
require 'oci/database_management/models/external_db_system_database_management_config_details'
require 'oci/database_management/models/external_db_system_discovery'
require 'oci/database_management/models/external_db_system_discovery_collection'
require 'oci/database_management/models/external_db_system_discovery_connector'
require 'oci/database_management/models/external_db_system_discovery_macs_connector'
require 'oci/database_management/models/external_db_system_discovery_summary'
require 'oci/database_management/models/external_db_system_macs_connector'
require 'oci/database_management/models/external_db_system_stack_monitoring_config_details'
require 'oci/database_management/models/external_db_system_summary'
require 'oci/database_management/models/external_exadata_database_system_summary'
require 'oci/database_management/models/external_exadata_infra_basic_info'
require 'oci/database_management/models/external_exadata_infrastructure'
require 'oci/database_management/models/external_exadata_infrastructure_collection'
require 'oci/database_management/models/external_exadata_infrastructure_discovery'
require 'oci/database_management/models/external_exadata_infrastructure_discovery_summary'
require 'oci/database_management/models/external_exadata_infrastructure_summary'
require 'oci/database_management/models/external_exadata_storage_connector'
require 'oci/database_management/models/external_exadata_storage_connector_collection'
require 'oci/database_management/models/external_exadata_storage_connector_status'
require 'oci/database_management/models/external_exadata_storage_connector_summary'
require 'oci/database_management/models/external_exadata_storage_grid'
require 'oci/database_management/models/external_exadata_storage_grid_summary'
require 'oci/database_management/models/external_exadata_storage_server'
require 'oci/database_management/models/external_exadata_storage_server_collection'
require 'oci/database_management/models/external_exadata_storage_server_summary'
require 'oci/database_management/models/external_listener'
require 'oci/database_management/models/external_listener_collection'
require 'oci/database_management/models/external_listener_endpoint'
require 'oci/database_management/models/external_listener_ipc_endpoint'
require 'oci/database_management/models/external_listener_service_collection'
require 'oci/database_management/models/external_listener_service_summary'
require 'oci/database_management/models/external_listener_serviced_database'
require 'oci/database_management/models/external_listener_summary'
require 'oci/database_management/models/external_listener_tcp_endpoint'
require 'oci/database_management/models/external_listener_tcps_endpoint'
require 'oci/database_management/models/external_pluggable_database_diagnostics_and_management_feature_details'
require 'oci/database_management/models/external_pluggable_database_feature_details'
require 'oci/database_management/models/external_serviced_asm'
require 'oci/database_management/models/external_serviced_database'
require 'oci/database_management/models/external_storage_grid_discovery_summary'
require 'oci/database_management/models/external_storage_server_discovery_summary'
require 'oci/database_management/models/failed_connections_aggregate_metrics'
require 'oci/database_management/models/fetch_sql_tuning_set_details'
require 'oci/database_management/models/finding_schema_or_operation'
require 'oci/database_management/models/fleet_metric_definition'
require 'oci/database_management/models/fleet_metric_summary_definition'
require 'oci/database_management/models/fleet_status_by_category'
require 'oci/database_management/models/fleet_summary'
require 'oci/database_management/models/heat_wave_cluster_status'
require 'oci/database_management/models/heat_wave_cluster_usage_metrics'
require 'oci/database_management/models/heat_wave_fleet_by_category'
require 'oci/database_management/models/heat_wave_fleet_metric_definition'
require 'oci/database_management/models/heat_wave_fleet_metric_summary_definition'
require 'oci/database_management/models/heat_wave_fleet_metrics'
require 'oci/database_management/models/heat_wave_fleet_summary'
require 'oci/database_management/models/heat_wave_node'
require 'oci/database_management/models/heat_wave_node_status'
require 'oci/database_management/models/historic_addm_result'
require 'oci/database_management/models/implement_optimizer_statistics_advisor_recommendations_details'
require 'oci/database_management/models/implement_optimizer_statistics_advisor_recommendations_job'
require 'oci/database_management/models/instance_details'
require 'oci/database_management/models/iorm_plan'
require 'oci/database_management/models/iorm_plan_objective_enum'
require 'oci/database_management/models/iorm_plan_status_enum'
require 'oci/database_management/models/job'
require 'oci/database_management/models/job_collection'
require 'oci/database_management/models/job_database'
require 'oci/database_management/models/job_execution'
require 'oci/database_management/models/job_execution_collection'
require 'oci/database_management/models/job_execution_result_details'
require 'oci/database_management/models/job_execution_result_location'
require 'oci/database_management/models/job_execution_summary'
require 'oci/database_management/models/job_executions_status_summary'
require 'oci/database_management/models/job_executions_status_summary_collection'
require 'oci/database_management/models/job_in_bind'
require 'oci/database_management/models/job_in_binds_details'
require 'oci/database_management/models/job_out_bind'
require 'oci/database_management/models/job_out_binds_details'
require 'oci/database_management/models/job_run'
require 'oci/database_management/models/job_run_collection'
require 'oci/database_management/models/job_run_summary'
require 'oci/database_management/models/job_schedule_details'
require 'oci/database_management/models/job_summary'
require 'oci/database_management/models/job_types'
require 'oci/database_management/models/lifecycle_states'
require 'oci/database_management/models/load_sql_plan_baselines_from_awr_details'
require 'oci/database_management/models/load_sql_plan_baselines_from_cursor_cache_details'
require 'oci/database_management/models/load_sql_tuning_set_details'
require 'oci/database_management/models/macs_connector_details'
require 'oci/database_management/models/managed_database'
require 'oci/database_management/models/managed_database_collection'
require 'oci/database_management/models/managed_database_credential'
require 'oci/database_management/models/managed_database_group'
require 'oci/database_management/models/managed_database_group_collection'
require 'oci/database_management/models/managed_database_group_summary'
require 'oci/database_management/models/managed_database_password_credential'
require 'oci/database_management/models/managed_database_secret_credential'
require 'oci/database_management/models/managed_database_summary'
require 'oci/database_management/models/managed_my_sql_database'
require 'oci/database_management/models/managed_my_sql_database_collection'
require 'oci/database_management/models/managed_my_sql_database_summary'
require 'oci/database_management/models/management_option'
require 'oci/database_management/models/mds_type'
require 'oci/database_management/models/memory_aggregate_metrics'
require 'oci/database_management/models/metric_data_point'
require 'oci/database_management/models/metric_dimension_definition'
require 'oci/database_management/models/metric_statistics_definition'
require 'oci/database_management/models/metrics_aggregation_range'
require 'oci/database_management/models/metrics_aggregation_range_collection'
require 'oci/database_management/models/modify_database_management_feature_details'
require 'oci/database_management/models/modify_pluggable_database_management_feature_details'
require 'oci/database_management/models/modify_snapshot_settings_details'
require 'oci/database_management/models/my_sql_configuration_data_collection'
require 'oci/database_management/models/my_sql_configuration_data_summary'
require 'oci/database_management/models/my_sql_data_collection'
require 'oci/database_management/models/my_sql_data_summary'
require 'oci/database_management/models/my_sql_database_status'
require 'oci/database_management/models/my_sql_database_usage_metrics'
require 'oci/database_management/models/my_sql_deployment_type'
require 'oci/database_management/models/my_sql_fleet_by_category'
require 'oci/database_management/models/my_sql_fleet_metric_definition'
require 'oci/database_management/models/my_sql_fleet_metric_summary_definition'
require 'oci/database_management/models/my_sql_fleet_metrics'
require 'oci/database_management/models/my_sql_fleet_summary'
require 'oci/database_management/models/named_credential'
require 'oci/database_management/models/named_credential_collection'
require 'oci/database_management/models/named_credential_content'
require 'oci/database_management/models/named_credential_content_type'
require 'oci/database_management/models/named_credential_scope'
require 'oci/database_management/models/named_credential_summary'
require 'oci/database_management/models/named_preferred_credential'
require 'oci/database_management/models/object_privilege_collection'
require 'oci/database_management/models/object_privilege_summary'
require 'oci/database_management/models/object_storage_job_execution_result_details'
require 'oci/database_management/models/object_storage_job_execution_result_location'
require 'oci/database_management/models/open_alert_history'
require 'oci/database_management/models/open_alert_summary'
require 'oci/database_management/models/optimizer_database'
require 'oci/database_management/models/optimizer_statistics_advisor_execution'
require 'oci/database_management/models/optimizer_statistics_advisor_execution_report'
require 'oci/database_management/models/optimizer_statistics_advisor_execution_script'
require 'oci/database_management/models/optimizer_statistics_advisor_execution_summary'
require 'oci/database_management/models/optimizer_statistics_advisor_executions_collection'
require 'oci/database_management/models/optimizer_statistics_collection_aggregation_summary'
require 'oci/database_management/models/optimizer_statistics_collection_aggregations_collection'
require 'oci/database_management/models/optimizer_statistics_collection_operation'
require 'oci/database_management/models/optimizer_statistics_collection_operation_summary'
require 'oci/database_management/models/optimizer_statistics_collection_operations_collection'
require 'oci/database_management/models/optimizer_statistics_group_by_types'
require 'oci/database_management/models/optimizer_statistics_operation_task'
require 'oci/database_management/models/optimizer_statistics_task_filter_types'
require 'oci/database_management/models/parameter_scope'
require 'oci/database_management/models/parent_group'
require 'oci/database_management/models/password_secret_access_mode'
require 'oci/database_management/models/patch_external_db_system_discovery_details'
require 'oci/database_management/models/patch_instruction'
require 'oci/database_management/models/patch_merge_instruction'
require 'oci/database_management/models/pdb_metrics'
require 'oci/database_management/models/pdb_status_details'
require 'oci/database_management/models/preferred_credential'
require 'oci/database_management/models/preferred_credential_collection'
require 'oci/database_management/models/preferred_credential_status'
require 'oci/database_management/models/preferred_credential_summary'
require 'oci/database_management/models/preferred_credential_type'
require 'oci/database_management/models/private_end_point_connector_details'
require 'oci/database_management/models/proxied_for_user_collection'
require 'oci/database_management/models/proxied_for_user_summary'
require 'oci/database_management/models/proxy_user_collection'
require 'oci/database_management/models/proxy_user_summary'
require 'oci/database_management/models/ranking_measure'
require 'oci/database_management/models/recommendation'
require 'oci/database_management/models/recommendation_example'
require 'oci/database_management/models/recommendation_example_line'
require 'oci/database_management/models/recommendation_rationale'
require 'oci/database_management/models/remove_data_file_details'
require 'oci/database_management/models/remove_managed_database_from_managed_database_group_details'
require 'oci/database_management/models/reset_database_parameters_details'
require 'oci/database_management/models/resize_data_file_details'
require 'oci/database_management/models/resource_type'
require 'oci/database_management/models/rest_credential'
require 'oci/database_management/models/role'
require 'oci/database_management/models/role_collection'
require 'oci/database_management/models/role_summary'
require 'oci/database_management/models/rule_finding'
require 'oci/database_management/models/run_historic_addm_details'
require 'oci/database_management/models/save_sql_tuning_set_as_details'
require 'oci/database_management/models/schema_definition'
require 'oci/database_management/models/snapshot_details'
require 'oci/database_management/models/sort_orders'
require 'oci/database_management/models/spm_evolve_task_parameters'
require 'oci/database_management/models/sql_cpu_activity'
require 'oci/database_management/models/sql_in_sql_tuning_set'
require 'oci/database_management/models/sql_job'
require 'oci/database_management/models/sql_metrics'
require 'oci/database_management/models/sql_plan_baseline'
require 'oci/database_management/models/sql_plan_baseline_aggregation'
require 'oci/database_management/models/sql_plan_baseline_aggregation_collection'
require 'oci/database_management/models/sql_plan_baseline_collection'
require 'oci/database_management/models/sql_plan_baseline_configuration'
require 'oci/database_management/models/sql_plan_baseline_dimensions'
require 'oci/database_management/models/sql_plan_baseline_job'
require 'oci/database_management/models/sql_plan_baseline_job_collection'
require 'oci/database_management/models/sql_plan_baseline_job_summary'
require 'oci/database_management/models/sql_plan_baseline_origin'
require 'oci/database_management/models/sql_plan_baseline_summary'
require 'oci/database_management/models/sql_tuning_advisor_task_collection'
require 'oci/database_management/models/sql_tuning_advisor_task_finding_collection'
require 'oci/database_management/models/sql_tuning_advisor_task_finding_summary'
require 'oci/database_management/models/sql_tuning_advisor_task_recommendation_collection'
require 'oci/database_management/models/sql_tuning_advisor_task_recommendation_summary'
require 'oci/database_management/models/sql_tuning_advisor_task_sql_execution_plan'
require 'oci/database_management/models/sql_tuning_advisor_task_summary'
require 'oci/database_management/models/sql_tuning_advisor_task_summary_finding_benefits'
require 'oci/database_management/models/sql_tuning_advisor_task_summary_finding_counts'
require 'oci/database_management/models/sql_tuning_advisor_task_summary_report'
require 'oci/database_management/models/sql_tuning_advisor_task_summary_report_index_finding_summary'
require 'oci/database_management/models/sql_tuning_advisor_task_summary_report_object_stat_finding_summary'
require 'oci/database_management/models/sql_tuning_advisor_task_summary_report_statement_counts'
require 'oci/database_management/models/sql_tuning_advisor_task_summary_report_statistics'
require 'oci/database_management/models/sql_tuning_advisor_task_summary_report_task_info'
require 'oci/database_management/models/sql_tuning_set'
require 'oci/database_management/models/sql_tuning_set_admin_action_status'
require 'oci/database_management/models/sql_tuning_set_admin_credential_details'
require 'oci/database_management/models/sql_tuning_set_admin_password_credential_details'
require 'oci/database_management/models/sql_tuning_set_admin_secret_credential_details'
require 'oci/database_management/models/sql_tuning_set_collection'
require 'oci/database_management/models/sql_tuning_set_input'
require 'oci/database_management/models/sql_tuning_set_status_types'
require 'oci/database_management/models/sql_tuning_set_summary'
require 'oci/database_management/models/sql_tuning_task_credential_details'
require 'oci/database_management/models/sql_tuning_task_credential_types'
require 'oci/database_management/models/sql_tuning_task_password_credential_details'
require 'oci/database_management/models/sql_tuning_task_plan_stats'
require 'oci/database_management/models/sql_tuning_task_return'
require 'oci/database_management/models/sql_tuning_task_secret_credential_details'
require 'oci/database_management/models/sql_tuning_task_sql_detail'
require 'oci/database_management/models/sql_tuning_task_sql_execution_plan_step'
require 'oci/database_management/models/sql_tuning_task_status_types'
require 'oci/database_management/models/start_sql_tuning_task_details'
require 'oci/database_management/models/statements_aggregate_metrics'
require 'oci/database_management/models/system_privilege_collection'
require 'oci/database_management/models/system_privilege_summary'
require 'oci/database_management/models/table_statistic_summary'
require 'oci/database_management/models/table_statistics_collection'
require 'oci/database_management/models/table_statistics_status_category'
require 'oci/database_management/models/tablespace'
require 'oci/database_management/models/tablespace_admin_credential_details'
require 'oci/database_management/models/tablespace_admin_password_credential_details'
require 'oci/database_management/models/tablespace_admin_secret_credential_details'
require 'oci/database_management/models/tablespace_admin_status'
require 'oci/database_management/models/tablespace_collection'
require 'oci/database_management/models/tablespace_storage_size'
require 'oci/database_management/models/tablespace_summary'
require 'oci/database_management/models/test_basic_preferred_credential_details'
require 'oci/database_management/models/test_named_credential_details'
require 'oci/database_management/models/test_named_credential_status'
require 'oci/database_management/models/test_named_preferred_credential_details'
require 'oci/database_management/models/test_preferred_credential_details'
require 'oci/database_management/models/test_preferred_credential_status'
require 'oci/database_management/models/time_series_metric_data_point'
require 'oci/database_management/models/time_series_metric_definition'
require 'oci/database_management/models/top_sql_cpu_activity'
require 'oci/database_management/models/update_basic_preferred_credential_details'
require 'oci/database_management/models/update_database_parameters_result'
require 'oci/database_management/models/update_db_management_private_endpoint_details'
require 'oci/database_management/models/update_external_asm_details'
require 'oci/database_management/models/update_external_asm_instance_details'
require 'oci/database_management/models/update_external_cluster_details'
require 'oci/database_management/models/update_external_cluster_instance_details'
require 'oci/database_management/models/update_external_db_home_details'
require 'oci/database_management/models/update_external_db_node_details'
require 'oci/database_management/models/update_external_db_system_connector_details'
require 'oci/database_management/models/update_external_db_system_details'
require 'oci/database_management/models/update_external_db_system_discovery_details'
require 'oci/database_management/models/update_external_db_system_macs_connector_details'
require 'oci/database_management/models/update_external_exadata_infrastructure_details'
require 'oci/database_management/models/update_external_exadata_storage_connector_details'
require 'oci/database_management/models/update_external_exadata_storage_grid_details'
require 'oci/database_management/models/update_external_exadata_storage_server_details'
require 'oci/database_management/models/update_external_listener_details'
require 'oci/database_management/models/update_job_details'
require 'oci/database_management/models/update_managed_database_details'
require 'oci/database_management/models/update_managed_database_group_details'
require 'oci/database_management/models/update_named_credential_details'
require 'oci/database_management/models/update_named_preferred_credential_details'
require 'oci/database_management/models/update_preferred_credential_details'
require 'oci/database_management/models/update_sql_job_details'
require 'oci/database_management/models/update_tablespace_details'
require 'oci/database_management/models/user'
require 'oci/database_management/models/user_collection'
require 'oci/database_management/models/user_summary'
require 'oci/database_management/models/validate_basic_filter_details'
require 'oci/database_management/models/work_request'
require 'oci/database_management/models/work_request_collection'
require 'oci/database_management/models/work_request_error'
require 'oci/database_management/models/work_request_error_collection'
require 'oci/database_management/models/work_request_log_entry'
require 'oci/database_management/models/work_request_log_entry_collection'
require 'oci/database_management/models/work_request_operation_type'
require 'oci/database_management/models/work_request_resource'
require 'oci/database_management/models/work_request_resource_action_type'
require 'oci/database_management/models/work_request_status'
require 'oci/database_management/models/work_request_sub_resource'
require 'oci/database_management/models/work_request_summary'
require 'oci/database_management/models/workload_type'

# Require generated clients
require 'oci/database_management/db_management_client'
require 'oci/database_management/db_management_client_composite_operations'
require 'oci/database_management/diagnosability_client'
require 'oci/database_management/managed_my_sql_databases_client'
require 'oci/database_management/perfhub_client'
require 'oci/database_management/sql_tuning_client'

# Require service utilities
require 'oci/database_management/util'
