# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20180828
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # The resource usage information.
  class EmWarehouse::Models::ResourceUsage
    # **[Required]** operations Insights Warehouse Identifier
    # @return [String]
    attr_accessor :operations_insights_warehouse_id

    # **[Required]** Unique identifier that is immutable on creation
    # @return [String]
    attr_accessor :id

    # EmInstanceCount
    # @return [Integer]
    attr_accessor :em_instance_count

    # EmInstance Target count
    # @return [Integer]
    attr_accessor :targets_count

    # List of emInstances
    # @return [Array<OCI::EmWarehouse::Models::EmInstancesDetails>]
    attr_accessor :em_instances

    # schema name
    # @return [String]
    attr_accessor :schema_name

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'operations_insights_warehouse_id': :'operationsInsightsWarehouseId',
        'id': :'id',
        'em_instance_count': :'emInstanceCount',
        'targets_count': :'targetsCount',
        'em_instances': :'emInstances',
        'schema_name': :'schemaName'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'operations_insights_warehouse_id': :'String',
        'id': :'String',
        'em_instance_count': :'Integer',
        'targets_count': :'Integer',
        'em_instances': :'Array<OCI::EmWarehouse::Models::EmInstancesDetails>',
        'schema_name': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :operations_insights_warehouse_id The value to assign to the {#operations_insights_warehouse_id} property
    # @option attributes [String] :id The value to assign to the {#id} property
    # @option attributes [Integer] :em_instance_count The value to assign to the {#em_instance_count} property
    # @option attributes [Integer] :targets_count The value to assign to the {#targets_count} property
    # @option attributes [Array<OCI::EmWarehouse::Models::EmInstancesDetails>] :em_instances The value to assign to the {#em_instances} property
    # @option attributes [String] :schema_name The value to assign to the {#schema_name} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.operations_insights_warehouse_id = attributes[:'operationsInsightsWarehouseId'] if attributes[:'operationsInsightsWarehouseId']

      raise 'You cannot provide both :operationsInsightsWarehouseId and :operations_insights_warehouse_id' if attributes.key?(:'operationsInsightsWarehouseId') && attributes.key?(:'operations_insights_warehouse_id')

      self.operations_insights_warehouse_id = attributes[:'operations_insights_warehouse_id'] if attributes[:'operations_insights_warehouse_id']

      self.id = attributes[:'id'] if attributes[:'id']

      self.em_instance_count = attributes[:'emInstanceCount'] if attributes[:'emInstanceCount']

      raise 'You cannot provide both :emInstanceCount and :em_instance_count' if attributes.key?(:'emInstanceCount') && attributes.key?(:'em_instance_count')

      self.em_instance_count = attributes[:'em_instance_count'] if attributes[:'em_instance_count']

      self.targets_count = attributes[:'targetsCount'] if attributes[:'targetsCount']

      raise 'You cannot provide both :targetsCount and :targets_count' if attributes.key?(:'targetsCount') && attributes.key?(:'targets_count')

      self.targets_count = attributes[:'targets_count'] if attributes[:'targets_count']

      self.em_instances = attributes[:'emInstances'] if attributes[:'emInstances']

      raise 'You cannot provide both :emInstances and :em_instances' if attributes.key?(:'emInstances') && attributes.key?(:'em_instances')

      self.em_instances = attributes[:'em_instances'] if attributes[:'em_instances']

      self.schema_name = attributes[:'schemaName'] if attributes[:'schemaName']

      raise 'You cannot provide both :schemaName and :schema_name' if attributes.key?(:'schemaName') && attributes.key?(:'schema_name')

      self.schema_name = attributes[:'schema_name'] if attributes[:'schema_name']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        operations_insights_warehouse_id == other.operations_insights_warehouse_id &&
        id == other.id &&
        em_instance_count == other.em_instance_count &&
        targets_count == other.targets_count &&
        em_instances == other.em_instances &&
        schema_name == other.schema_name
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [operations_insights_warehouse_id, id, em_instance_count, targets_count, em_instances, schema_name].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
