# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20171215

module OCI
  module FileStorage
    # Module containing models for requests made to, and responses received from,
    # OCI FileStorage services
    module Models
    end
  end
end

# Require models
require 'oci/file_storage/models/change_file_system_compartment_details'
require 'oci/file_storage/models/change_filesystem_snapshot_policy_compartment_details'
require 'oci/file_storage/models/change_mount_target_compartment_details'
require 'oci/file_storage/models/change_outbound_connector_compartment_details'
require 'oci/file_storage/models/change_replication_compartment_details'
require 'oci/file_storage/models/client_options'
require 'oci/file_storage/models/create_export_details'
require 'oci/file_storage/models/create_file_system_details'
require 'oci/file_storage/models/create_filesystem_snapshot_policy_details'
require 'oci/file_storage/models/create_kerberos_details'
require 'oci/file_storage/models/create_ldap_bind_account_details'
require 'oci/file_storage/models/create_ldap_idmap_details'
require 'oci/file_storage/models/create_mount_target_details'
require 'oci/file_storage/models/create_outbound_connector_details'
require 'oci/file_storage/models/create_replication_details'
require 'oci/file_storage/models/create_snapshot_details'
require 'oci/file_storage/models/endpoint'
require 'oci/file_storage/models/export'
require 'oci/file_storage/models/export_set'
require 'oci/file_storage/models/export_set_summary'
require 'oci/file_storage/models/export_summary'
require 'oci/file_storage/models/file_system'
require 'oci/file_storage/models/file_system_summary'
require 'oci/file_storage/models/filesystem_snapshot_policy'
require 'oci/file_storage/models/filesystem_snapshot_policy_summary'
require 'oci/file_storage/models/kerberos'
require 'oci/file_storage/models/kerberos_keytab_entry'
require 'oci/file_storage/models/key_tab_secret_details'
require 'oci/file_storage/models/ldap_bind_account'
require 'oci/file_storage/models/ldap_bind_account_summary'
require 'oci/file_storage/models/ldap_idmap'
require 'oci/file_storage/models/mount_target'
require 'oci/file_storage/models/mount_target_summary'
require 'oci/file_storage/models/outbound_connector'
require 'oci/file_storage/models/outbound_connector_summary'
require 'oci/file_storage/models/replication'
require 'oci/file_storage/models/replication_estimate'
require 'oci/file_storage/models/replication_summary'
require 'oci/file_storage/models/replication_target'
require 'oci/file_storage/models/replication_target_summary'
require 'oci/file_storage/models/snapshot'
require 'oci/file_storage/models/snapshot_schedule'
require 'oci/file_storage/models/snapshot_summary'
require 'oci/file_storage/models/source_details'
require 'oci/file_storage/models/update_export_details'
require 'oci/file_storage/models/update_export_set_details'
require 'oci/file_storage/models/update_file_system_details'
require 'oci/file_storage/models/update_filesystem_snapshot_policy_details'
require 'oci/file_storage/models/update_kerberos_details'
require 'oci/file_storage/models/update_ldap_idmap_details'
require 'oci/file_storage/models/update_mount_target_details'
require 'oci/file_storage/models/update_outbound_connector_details'
require 'oci/file_storage/models/update_replication_details'
require 'oci/file_storage/models/update_snapshot_details'
require 'oci/file_storage/models/validate_key_tabs_details'
require 'oci/file_storage/models/validate_key_tabs_response_details'

# Require generated clients
require 'oci/file_storage/file_storage_client'
require 'oci/file_storage/file_storage_client_composite_operations'

# Require service utilities
require 'oci/file_storage/util'
