# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220528
require 'date'
require_relative 'fsu_job'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Apply Exadata Fleet Update Job resource.
  #
  class FleetSoftwareUpdate::Models::ApplyFsuJob < FleetSoftwareUpdate::Models::FsuJob
    # **[Required]** OCID of the Exadata Fleet Update Collection that the job is executing on.
    #
    # @return [String]
    attr_accessor :fsu_collection_id

    # **[Required]** OCID of the Exadata Fleet Update Cycle that this job is part of.
    #
    # @return [String]
    attr_accessor :fsu_cycle_id

    # OCID of Target resource on which the job is executing the action.
    #
    # @return [String]
    attr_accessor :target_id

    # @return [OCI::FleetSoftwareUpdate::Models::ScheduleDetails]
    attr_accessor :schedule

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'id',
        'display_name': :'displayName',
        'type': :'type',
        'compartment_id': :'compartmentId',
        'fsu_action_id': :'fsuActionId',
        'progress': :'progress',
        'time_created': :'timeCreated',
        'time_started': :'timeStarted',
        'time_updated': :'timeUpdated',
        'time_finished': :'timeFinished',
        'lifecycle_state': :'lifecycleState',
        'lifecycle_details': :'lifecycleDetails',
        'freeform_tags': :'freeformTags',
        'defined_tags': :'definedTags',
        'system_tags': :'systemTags',
        'fsu_collection_id': :'fsuCollectionId',
        'fsu_cycle_id': :'fsuCycleId',
        'target_id': :'targetId',
        'schedule': :'schedule'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'String',
        'display_name': :'String',
        'type': :'String',
        'compartment_id': :'String',
        'fsu_action_id': :'String',
        'progress': :'OCI::FleetSoftwareUpdate::Models::JobProgressDetails',
        'time_created': :'DateTime',
        'time_started': :'DateTime',
        'time_updated': :'DateTime',
        'time_finished': :'DateTime',
        'lifecycle_state': :'String',
        'lifecycle_details': :'String',
        'freeform_tags': :'Hash<String, String>',
        'defined_tags': :'Hash<String, Hash<String, Object>>',
        'system_tags': :'Hash<String, Hash<String, Object>>',
        'fsu_collection_id': :'String',
        'fsu_cycle_id': :'String',
        'target_id': :'String',
        'schedule': :'OCI::FleetSoftwareUpdate::Models::ScheduleDetails'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :id The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#id #id} proprety
    # @option attributes [String] :display_name The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#display_name #display_name} proprety
    # @option attributes [String] :compartment_id The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#compartment_id #compartment_id} proprety
    # @option attributes [String] :fsu_action_id The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#fsu_action_id #fsu_action_id} proprety
    # @option attributes [OCI::FleetSoftwareUpdate::Models::JobProgressDetails] :progress The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#progress #progress} proprety
    # @option attributes [DateTime] :time_created The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#time_created #time_created} proprety
    # @option attributes [DateTime] :time_started The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#time_started #time_started} proprety
    # @option attributes [DateTime] :time_updated The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#time_updated #time_updated} proprety
    # @option attributes [DateTime] :time_finished The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#time_finished #time_finished} proprety
    # @option attributes [String] :lifecycle_state The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#lifecycle_state #lifecycle_state} proprety
    # @option attributes [String] :lifecycle_details The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#lifecycle_details #lifecycle_details} proprety
    # @option attributes [Hash<String, String>] :freeform_tags The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#freeform_tags #freeform_tags} proprety
    # @option attributes [Hash<String, Hash<String, Object>>] :defined_tags The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#defined_tags #defined_tags} proprety
    # @option attributes [Hash<String, Hash<String, Object>>] :system_tags The value to assign to the {OCI::FleetSoftwareUpdate::Models::FsuJob#system_tags #system_tags} proprety
    # @option attributes [String] :fsu_collection_id The value to assign to the {#fsu_collection_id} property
    # @option attributes [String] :fsu_cycle_id The value to assign to the {#fsu_cycle_id} property
    # @option attributes [String] :target_id The value to assign to the {#target_id} property
    # @option attributes [OCI::FleetSoftwareUpdate::Models::ScheduleDetails] :schedule The value to assign to the {#schedule} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      attributes['type'] = 'APPLY'

      super(attributes)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.fsu_collection_id = attributes[:'fsuCollectionId'] if attributes[:'fsuCollectionId']

      raise 'You cannot provide both :fsuCollectionId and :fsu_collection_id' if attributes.key?(:'fsuCollectionId') && attributes.key?(:'fsu_collection_id')

      self.fsu_collection_id = attributes[:'fsu_collection_id'] if attributes[:'fsu_collection_id']

      self.fsu_cycle_id = attributes[:'fsuCycleId'] if attributes[:'fsuCycleId']

      raise 'You cannot provide both :fsuCycleId and :fsu_cycle_id' if attributes.key?(:'fsuCycleId') && attributes.key?(:'fsu_cycle_id')

      self.fsu_cycle_id = attributes[:'fsu_cycle_id'] if attributes[:'fsu_cycle_id']

      self.target_id = attributes[:'targetId'] if attributes[:'targetId']

      raise 'You cannot provide both :targetId and :target_id' if attributes.key?(:'targetId') && attributes.key?(:'target_id')

      self.target_id = attributes[:'target_id'] if attributes[:'target_id']

      self.schedule = attributes[:'schedule'] if attributes[:'schedule']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        id == other.id &&
        display_name == other.display_name &&
        type == other.type &&
        compartment_id == other.compartment_id &&
        fsu_action_id == other.fsu_action_id &&
        progress == other.progress &&
        time_created == other.time_created &&
        time_started == other.time_started &&
        time_updated == other.time_updated &&
        time_finished == other.time_finished &&
        lifecycle_state == other.lifecycle_state &&
        lifecycle_details == other.lifecycle_details &&
        freeform_tags == other.freeform_tags &&
        defined_tags == other.defined_tags &&
        system_tags == other.system_tags &&
        fsu_collection_id == other.fsu_collection_id &&
        fsu_cycle_id == other.fsu_cycle_id &&
        target_id == other.target_id &&
        schedule == other.schedule
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, display_name, type, compartment_id, fsu_action_id, progress, time_created, time_started, time_updated, time_finished, lifecycle_state, lifecycle_details, freeform_tags, defined_tags, system_tags, fsu_collection_id, fsu_cycle_id, target_id, schedule].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
