# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20211201

module OCI
  module FusionApps
    # Module containing models for requests made to, and responses received from,
    # OCI FusionApps services
    module Models
    end
  end
end

# Require models
require 'oci/fusion_apps/models/action'
require 'oci/fusion_apps/models/admin_user_collection'
require 'oci/fusion_apps/models/admin_user_summary'
require 'oci/fusion_apps/models/allow_rule'
require 'oci/fusion_apps/models/capabilities'
require 'oci/fusion_apps/models/change_fusion_environment_compartment_details'
require 'oci/fusion_apps/models/change_fusion_environment_family_compartment_details'
require 'oci/fusion_apps/models/create_data_masking_activity_details'
require 'oci/fusion_apps/models/create_fusion_environment_admin_user_details'
require 'oci/fusion_apps/models/create_fusion_environment_details'
require 'oci/fusion_apps/models/create_fusion_environment_family_details'
require 'oci/fusion_apps/models/create_refresh_activity_details'
require 'oci/fusion_apps/models/create_service_attachment_details'
require 'oci/fusion_apps/models/data_masking_activity'
require 'oci/fusion_apps/models/data_masking_activity_collection'
require 'oci/fusion_apps/models/data_masking_activity_summary'
require 'oci/fusion_apps/models/environment_role'
require 'oci/fusion_apps/models/family_maintenance_policy'
require 'oci/fusion_apps/models/fusion_environment'
require 'oci/fusion_apps/models/fusion_environment_collection'
require 'oci/fusion_apps/models/fusion_environment_family'
require 'oci/fusion_apps/models/fusion_environment_family_collection'
require 'oci/fusion_apps/models/fusion_environment_family_limits_and_usage'
require 'oci/fusion_apps/models/fusion_environment_family_summary'
require 'oci/fusion_apps/models/fusion_environment_status'
require 'oci/fusion_apps/models/fusion_environment_summary'
require 'oci/fusion_apps/models/get_maintenance_policy_details'
require 'oci/fusion_apps/models/kms_key_info'
require 'oci/fusion_apps/models/limit_and_usage'
require 'oci/fusion_apps/models/maintenance_policy'
require 'oci/fusion_apps/models/patch_action'
require 'oci/fusion_apps/models/quarterly_upgrade_begin_times'
require 'oci/fusion_apps/models/refresh_activity'
require 'oci/fusion_apps/models/refresh_activity_collection'
require 'oci/fusion_apps/models/refresh_activity_summary'
require 'oci/fusion_apps/models/refresh_details'
require 'oci/fusion_apps/models/refresh_issue_details'
require 'oci/fusion_apps/models/reset_fusion_environment_password_details'
require 'oci/fusion_apps/models/rule'
require 'oci/fusion_apps/models/rule_condition'
require 'oci/fusion_apps/models/scheduled_activity'
require 'oci/fusion_apps/models/scheduled_activity_collection'
require 'oci/fusion_apps/models/scheduled_activity_summary'
require 'oci/fusion_apps/models/service_attachment'
require 'oci/fusion_apps/models/service_attachment_collection'
require 'oci/fusion_apps/models/service_attachment_summary'
require 'oci/fusion_apps/models/source_ip_address_condition'
require 'oci/fusion_apps/models/source_vcn_id_condition'
require 'oci/fusion_apps/models/source_vcn_ip_address_condition'
require 'oci/fusion_apps/models/subscription'
require 'oci/fusion_apps/models/subscription_detail'
require 'oci/fusion_apps/models/subscription_sku'
require 'oci/fusion_apps/models/time_available_for_refresh'
require 'oci/fusion_apps/models/time_available_for_refresh_collection'
require 'oci/fusion_apps/models/time_available_for_refresh_summary'
require 'oci/fusion_apps/models/update_family_maintenance_policy_details'
require 'oci/fusion_apps/models/update_fusion_environment_details'
require 'oci/fusion_apps/models/update_fusion_environment_family_details'
require 'oci/fusion_apps/models/update_refresh_activity_details'
require 'oci/fusion_apps/models/upgrade_action'
require 'oci/fusion_apps/models/verify_service_attachment_details'
require 'oci/fusion_apps/models/vertex_action'
require 'oci/fusion_apps/models/work_request'
require 'oci/fusion_apps/models/work_request_error'
require 'oci/fusion_apps/models/work_request_error_collection'
require 'oci/fusion_apps/models/work_request_log_entry'
require 'oci/fusion_apps/models/work_request_log_entry_collection'
require 'oci/fusion_apps/models/work_request_resource'
require 'oci/fusion_apps/models/work_request_summary'
require 'oci/fusion_apps/models/work_request_summary_collection'

# Require generated clients
require 'oci/fusion_apps/fusion_applications_client'
require 'oci/fusion_apps/fusion_applications_client_composite_operations'

# Require service utilities
require 'oci/fusion_apps/util'
