# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20230301

module OCI
  module GloballyDistributedDatabase
    # Module containing models for requests made to, and responses received from,
    # OCI GloballyDistributedDatabase services
    module Models
    end
  end
end

# Require models
require 'oci/globally_distributed_database/models/action_type'
require 'oci/globally_distributed_database/models/change_private_endpoint_compartment_details'
require 'oci/globally_distributed_database/models/change_sharded_database_compartment_details'
require 'oci/globally_distributed_database/models/configure_sharded_database_gsms_details'
require 'oci/globally_distributed_database/models/connection_string'
require 'oci/globally_distributed_database/models/create_dedicated_catalog_detail'
require 'oci/globally_distributed_database/models/create_dedicated_shard_detail'
require 'oci/globally_distributed_database/models/create_dedicated_sharded_database'
require 'oci/globally_distributed_database/models/create_private_endpoint_details'
require 'oci/globally_distributed_database/models/create_sharded_database_details'
require 'oci/globally_distributed_database/models/dedicated_catalog_details'
require 'oci/globally_distributed_database/models/dedicated_shard_details'
require 'oci/globally_distributed_database/models/dedicated_shard_or_catalog_encryption_key_details'
require 'oci/globally_distributed_database/models/dedicated_sharded_database'
require 'oci/globally_distributed_database/models/dedicated_sharded_database_summary'
require 'oci/globally_distributed_database/models/fetch_shardable_cloud_autonomous_vm_clusters_details'
require 'oci/globally_distributed_database/models/generate_wallet_details'
require 'oci/globally_distributed_database/models/gsm_details'
require 'oci/globally_distributed_database/models/operation_status'
require 'oci/globally_distributed_database/models/operation_type'
require 'oci/globally_distributed_database/models/patch_insert_instruction'
require 'oci/globally_distributed_database/models/patch_instruction'
require 'oci/globally_distributed_database/models/patch_merge_instruction'
require 'oci/globally_distributed_database/models/patch_remove_instruction'
require 'oci/globally_distributed_database/models/patch_sharded_database_details'
require 'oci/globally_distributed_database/models/prevalidate_create_payload'
require 'oci/globally_distributed_database/models/prevalidate_patch_payload'
require 'oci/globally_distributed_database/models/prevalidate_payload'
require 'oci/globally_distributed_database/models/prevalidate_sharded_database_details'
require 'oci/globally_distributed_database/models/prevalidate_sharded_database_result'
require 'oci/globally_distributed_database/models/private_endpoint'
require 'oci/globally_distributed_database/models/private_endpoint_collection'
require 'oci/globally_distributed_database/models/private_endpoint_summary'
require 'oci/globally_distributed_database/models/shardable_cloud_autonomous_vm_cluster_summary'
require 'oci/globally_distributed_database/models/shardable_cloud_autonomous_vm_clusters'
require 'oci/globally_distributed_database/models/sharded_database'
require 'oci/globally_distributed_database/models/sharded_database_collection'
require 'oci/globally_distributed_database/models/sharded_database_summary'
require 'oci/globally_distributed_database/models/sort_order'
require 'oci/globally_distributed_database/models/update_private_endpoint_details'
require 'oci/globally_distributed_database/models/update_sharded_database_details'
require 'oci/globally_distributed_database/models/upload_signed_certificate_and_generate_wallet_details'
require 'oci/globally_distributed_database/models/work_request'
require 'oci/globally_distributed_database/models/work_request_error'
require 'oci/globally_distributed_database/models/work_request_error_collection'
require 'oci/globally_distributed_database/models/work_request_log_entry'
require 'oci/globally_distributed_database/models/work_request_log_entry_collection'
require 'oci/globally_distributed_database/models/work_request_resource'
require 'oci/globally_distributed_database/models/work_request_resource_metadata_key'
require 'oci/globally_distributed_database/models/work_request_summary'
require 'oci/globally_distributed_database/models/work_request_summary_collection'

# Require generated clients
require 'oci/globally_distributed_database/sharded_database_service_client'
require 'oci/globally_distributed_database/sharded_database_service_client_composite_operations'

# Require service utilities
require 'oci/globally_distributed_database/util'
