# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: v1
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # ResourcePrincipalSessionTokenRequest model.
  class IdentityDataPlane::Models::ResourcePrincipalSessionTokenRequest
    # **[Required]** The resource principal token.
    # @return [String]
    attr_accessor :resource_principal_token

    # **[Required]** The service principal session token.
    # @return [String]
    attr_accessor :service_principal_session_token

    # **[Required]** The session public key.
    # @return [String]
    attr_accessor :session_public_key

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'resource_principal_token': :'resourcePrincipalToken',
        'service_principal_session_token': :'servicePrincipalSessionToken',
        'session_public_key': :'sessionPublicKey'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'resource_principal_token': :'String',
        'service_principal_session_token': :'String',
        'session_public_key': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :resource_principal_token The value to assign to the {#resource_principal_token} property
    # @option attributes [String] :service_principal_session_token The value to assign to the {#service_principal_session_token} property
    # @option attributes [String] :session_public_key The value to assign to the {#session_public_key} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.resource_principal_token = attributes[:'resourcePrincipalToken'] if attributes[:'resourcePrincipalToken']

      raise 'You cannot provide both :resourcePrincipalToken and :resource_principal_token' if attributes.key?(:'resourcePrincipalToken') && attributes.key?(:'resource_principal_token')

      self.resource_principal_token = attributes[:'resource_principal_token'] if attributes[:'resource_principal_token']

      self.service_principal_session_token = attributes[:'servicePrincipalSessionToken'] if attributes[:'servicePrincipalSessionToken']

      raise 'You cannot provide both :servicePrincipalSessionToken and :service_principal_session_token' if attributes.key?(:'servicePrincipalSessionToken') && attributes.key?(:'service_principal_session_token')

      self.service_principal_session_token = attributes[:'service_principal_session_token'] if attributes[:'service_principal_session_token']

      self.session_public_key = attributes[:'sessionPublicKey'] if attributes[:'sessionPublicKey']

      raise 'You cannot provide both :sessionPublicKey and :session_public_key' if attributes.key?(:'sessionPublicKey') && attributes.key?(:'session_public_key')

      self.session_public_key = attributes[:'session_public_key'] if attributes[:'session_public_key']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        resource_principal_token == other.resource_principal_token &&
        service_principal_session_token == other.service_principal_session_token &&
        session_public_key == other.session_public_key
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [resource_principal_token, service_principal_session_token, session_public_key].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
