# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210610

module OCI
  module Jms
    # Module containing models for requests made to, and responses received from,
    # OCI Jms services
    module Models
    end
  end
end

# Require models
require 'oci/jms/models/action_type'
require 'oci/jms/models/add_fleet_installation_sites_details'
require 'oci/jms/models/advanced_usage_tracking'
require 'oci/jms/models/agent'
require 'oci/jms/models/agent_type'
require 'oci/jms/models/algorithms'
require 'oci/jms/models/announcement_collection'
require 'oci/jms/models/announcement_sort_by'
require 'oci/jms/models/announcement_summary'
require 'oci/jms/models/application_execution_type'
require 'oci/jms/models/application_installation_sort_by'
require 'oci/jms/models/application_installation_usage_summary'
require 'oci/jms/models/application_installation_usage_summary_collection'
require 'oci/jms/models/application_sort_by'
require 'oci/jms/models/application_usage'
require 'oci/jms/models/application_usage_collection'
require 'oci/jms/models/application_work_item_details'
require 'oci/jms/models/artifact_content_type'
require 'oci/jms/models/basic_work_item_details'
require 'oci/jms/models/blocklist'
require 'oci/jms/models/blocklist_collection'
require 'oci/jms/models/blocklist_entry'
require 'oci/jms/models/blocklist_sort_by'
require 'oci/jms/models/blocklist_target'
require 'oci/jms/models/change_fleet_compartment_details'
require 'oci/jms/models/create_blocklist_details'
require 'oci/jms/models/create_drs_file_details'
require 'oci/jms/models/create_fleet_details'
require 'oci/jms/models/crypto_analysis_result'
require 'oci/jms/models/crypto_analysis_result_collection'
require 'oci/jms/models/crypto_analysis_result_mode'
require 'oci/jms/models/crypto_analysis_result_sort_by'
require 'oci/jms/models/crypto_analysis_result_summary'
require 'oci/jms/models/crypto_event_analysis'
require 'oci/jms/models/custom_log'
require 'oci/jms/models/deployed_application_installation_sort_by'
require 'oci/jms/models/deployed_application_installation_usage_summary'
require 'oci/jms/models/deployed_application_installation_usage_summary_collection'
require 'oci/jms/models/deployed_application_sort_by'
require 'oci/jms/models/deployed_application_usage'
require 'oci/jms/models/deployed_application_usage_collection'
require 'oci/jms/models/disable_drs_details'
require 'oci/jms/models/drs_file'
require 'oci/jms/models/drs_file_collection'
require 'oci/jms/models/drs_file_sort_by'
require 'oci/jms/models/drs_file_status'
require 'oci/jms/models/drs_file_summary'
require 'oci/jms/models/drs_target'
require 'oci/jms/models/enable_drs_details'
require 'oci/jms/models/existing_installation_site_id'
require 'oci/jms/models/export_duration'
require 'oci/jms/models/export_frequency'
require 'oci/jms/models/export_resources'
require 'oci/jms/models/export_run_status'
require 'oci/jms/models/export_setting'
require 'oci/jms/models/export_status'
require 'oci/jms/models/fleet'
require 'oci/jms/models/fleet_advanced_feature_configuration'
require 'oci/jms/models/fleet_agent_configuration'
require 'oci/jms/models/fleet_agent_os_configuration'
require 'oci/jms/models/fleet_collection'
require 'oci/jms/models/fleet_diagnosis_collection'
require 'oci/jms/models/fleet_diagnosis_summary'
require 'oci/jms/models/fleet_summary'
require 'oci/jms/models/generate_agent_deploy_script_details'
require 'oci/jms/models/global_logging_level'
require 'oci/jms/models/installation_site'
require 'oci/jms/models/installation_site_collection'
require 'oci/jms/models/installation_site_sort_by'
require 'oci/jms/models/installation_site_summary'
require 'oci/jms/models/installation_sort_by'
require 'oci/jms/models/installation_usage'
require 'oci/jms/models/installation_usage_collection'
require 'oci/jms/models/java_artifact'
require 'oci/jms/models/java_family'
require 'oci/jms/models/java_family_collection'
require 'oci/jms/models/java_family_sort_by'
require 'oci/jms/models/java_family_summary'
require 'oci/jms/models/java_license'
require 'oci/jms/models/java_migration_analysis'
require 'oci/jms/models/java_migration_analysis_result'
require 'oci/jms/models/java_migration_analysis_result_collection'
require 'oci/jms/models/java_migration_analysis_result_sort_by'
require 'oci/jms/models/java_migration_analysis_result_summary'
require 'oci/jms/models/java_migration_analysis_target'
require 'oci/jms/models/java_release'
require 'oci/jms/models/java_release_collection'
require 'oci/jms/models/java_release_sort_by'
require 'oci/jms/models/java_release_summary'
require 'oci/jms/models/java_runtime_id'
require 'oci/jms/models/java_server_instance_sort_by'
require 'oci/jms/models/java_server_instance_usage'
require 'oci/jms/models/java_server_instance_usage_collection'
require 'oci/jms/models/java_server_sort_by'
require 'oci/jms/models/java_server_usage'
require 'oci/jms/models/java_server_usage_collection'
require 'oci/jms/models/jfr_attachment_target'
require 'oci/jms/models/jfr_recording'
require 'oci/jms/models/jre_security_status'
require 'oci/jms/models/jre_sort_by'
require 'oci/jms/models/jre_usage'
require 'oci/jms/models/jre_usage_collection'
require 'oci/jms/models/key_size_algorithm'
require 'oci/jms/models/lcm'
require 'oci/jms/models/lcm_work_item_details'
require 'oci/jms/models/library_sort_by'
require 'oci/jms/models/library_usage'
require 'oci/jms/models/library_usage_collection'
require 'oci/jms/models/license_type'
require 'oci/jms/models/lifecycle_state'
require 'oci/jms/models/manage_drs_details'
require 'oci/jms/models/managed_instance_sort_by'
require 'oci/jms/models/managed_instance_type'
require 'oci/jms/models/managed_instance_usage'
require 'oci/jms/models/managed_instance_usage_collection'
require 'oci/jms/models/minimum_key_size_settings'
require 'oci/jms/models/new_installation_site'
require 'oci/jms/models/operating_system'
require 'oci/jms/models/operation_status'
require 'oci/jms/models/operation_type'
require 'oci/jms/models/os_family'
require 'oci/jms/models/patch_detail'
require 'oci/jms/models/performance_tuning_analysis'
require 'oci/jms/models/performance_tuning_analysis_result'
require 'oci/jms/models/performance_tuning_analysis_result_collection'
require 'oci/jms/models/performance_tuning_analysis_result_sort_by'
require 'oci/jms/models/performance_tuning_analysis_result_summary'
require 'oci/jms/models/performance_tuning_result_status'
require 'oci/jms/models/plugin'
require 'oci/jms/models/post_installation_action_settings'
require 'oci/jms/models/post_installation_actions'
require 'oci/jms/models/principal'
require 'oci/jms/models/proxies'
require 'oci/jms/models/release_type'
require 'oci/jms/models/remove_fleet_installation_sites_details'
require 'oci/jms/models/request_crypto_analyses_details'
require 'oci/jms/models/request_java_migration_analyses_details'
require 'oci/jms/models/request_jfr_recordings_details'
require 'oci/jms/models/request_performance_tuning_analyses_details'
require 'oci/jms/models/resource_inventory'
require 'oci/jms/models/scan_java_server_usage_details'
require 'oci/jms/models/scan_library_usage_details'
require 'oci/jms/models/sort_by'
require 'oci/jms/models/sort_order'
require 'oci/jms/models/summarize_application_usage_fields'
require 'oci/jms/models/summarize_installation_usage_fields'
require 'oci/jms/models/summarize_jre_usage_fields'
require 'oci/jms/models/summarize_managed_instance_usage_fields'
require 'oci/jms/models/summarized_events_log'
require 'oci/jms/models/support_type'
require 'oci/jms/models/tls_versions'
require 'oci/jms/models/update_drs_file_details'
require 'oci/jms/models/update_export_setting_details'
require 'oci/jms/models/update_fleet_advanced_feature_configuration_details'
require 'oci/jms/models/update_fleet_agent_configuration_details'
require 'oci/jms/models/update_fleet_details'
require 'oci/jms/models/work_item_collection'
require 'oci/jms/models/work_item_details'
require 'oci/jms/models/work_item_status'
require 'oci/jms/models/work_item_summary'
require 'oci/jms/models/work_item_type'
require 'oci/jms/models/work_request'
require 'oci/jms/models/work_request_collection'
require 'oci/jms/models/work_request_error'
require 'oci/jms/models/work_request_error_collection'
require 'oci/jms/models/work_request_log_entry'
require 'oci/jms/models/work_request_log_entry_collection'
require 'oci/jms/models/work_request_resource'

# Require generated clients
require 'oci/jms/java_management_service_client'
require 'oci/jms/java_management_service_client_composite_operations'

# Require service utilities
require 'oci/jms/util'
