# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210610
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # The blocklist record details.
  class Jms::Models::CreateBlocklistDetails
    OPERATION_ENUM = [
      OPERATION_CREATE_FLEET = 'CREATE_FLEET'.freeze,
      OPERATION_DELETE_FLEET = 'DELETE_FLEET'.freeze,
      OPERATION_MOVE_FLEET = 'MOVE_FLEET'.freeze,
      OPERATION_UPDATE_FLEET = 'UPDATE_FLEET'.freeze,
      OPERATION_UPDATE_FLEET_AGENT_CONFIGURATION = 'UPDATE_FLEET_AGENT_CONFIGURATION'.freeze,
      OPERATION_DELETE_JAVA_INSTALLATION = 'DELETE_JAVA_INSTALLATION'.freeze,
      OPERATION_CREATE_JAVA_INSTALLATION = 'CREATE_JAVA_INSTALLATION'.freeze,
      OPERATION_COLLECT_JFR = 'COLLECT_JFR'.freeze,
      OPERATION_REQUEST_CRYPTO_EVENT_ANALYSIS = 'REQUEST_CRYPTO_EVENT_ANALYSIS'.freeze,
      OPERATION_REQUEST_PERFORMANCE_TUNING_ANALYSIS = 'REQUEST_PERFORMANCE_TUNING_ANALYSIS'.freeze,
      OPERATION_REQUEST_JAVA_MIGRATION_ANALYSIS = 'REQUEST_JAVA_MIGRATION_ANALYSIS'.freeze,
      OPERATION_DELETE_JMS_REPORT = 'DELETE_JMS_REPORT'.freeze,
      OPERATION_SCAN_JAVA_SERVER_USAGE = 'SCAN_JAVA_SERVER_USAGE'.freeze,
      OPERATION_SCAN_LIBRARY_USAGE = 'SCAN_LIBRARY_USAGE'.freeze,
      OPERATION_EXPORT_DATA_CSV = 'EXPORT_DATA_CSV'.freeze,
      OPERATION_CREATE_DRS_FILE = 'CREATE_DRS_FILE'.freeze,
      OPERATION_UPDATE_DRS_FILE = 'UPDATE_DRS_FILE'.freeze,
      OPERATION_DELETE_DRS_FILE = 'DELETE_DRS_FILE'.freeze,
      OPERATION_ENABLE_DRS = 'ENABLE_DRS'.freeze,
      OPERATION_DISABLE_DRS = 'DISABLE_DRS'.freeze
    ].freeze

    # This attribute is required.
    # @return [OCI::Jms::Models::BlocklistTarget]
    attr_accessor :target

    # **[Required]** The operation type
    # @return [String]
    attr_reader :operation

    # The reason why the operation is blocklisted
    # @return [String]
    attr_accessor :reason

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'target': :'target',
        'operation': :'operation',
        'reason': :'reason'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'target': :'OCI::Jms::Models::BlocklistTarget',
        'operation': :'String',
        'reason': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [OCI::Jms::Models::BlocklistTarget] :target The value to assign to the {#target} property
    # @option attributes [String] :operation The value to assign to the {#operation} property
    # @option attributes [String] :reason The value to assign to the {#reason} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.target = attributes[:'target'] if attributes[:'target']

      self.operation = attributes[:'operation'] if attributes[:'operation']

      self.reason = attributes[:'reason'] if attributes[:'reason']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] operation Object to be assigned
    def operation=(operation)
      raise "Invalid value for 'operation': this must be one of the values in OPERATION_ENUM." if operation && !OPERATION_ENUM.include?(operation)

      @operation = operation
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        target == other.target &&
        operation == other.operation &&
        reason == other.reason
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [target, operation, reason].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
