# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220126

module OCI
  module Lockbox
    # Module containing models for requests made to, and responses received from,
    # OCI Lockbox services
    module Models
    end
  end
end

# Require models
require 'oci/lockbox/models/access_context_attribute'
require 'oci/lockbox/models/access_context_attribute_collection'
require 'oci/lockbox/models/access_materials'
require 'oci/lockbox/models/access_request'
require 'oci/lockbox/models/access_request_action_type'
require 'oci/lockbox/models/access_request_collection'
require 'oci/lockbox/models/access_request_ext'
require 'oci/lockbox/models/access_request_summary'
require 'oci/lockbox/models/action_type'
require 'oci/lockbox/models/activity_log'
require 'oci/lockbox/models/approval_template'
require 'oci/lockbox/models/approval_template_collection'
require 'oci/lockbox/models/approval_template_summary'
require 'oci/lockbox/models/approver_info'
require 'oci/lockbox/models/approver_levels'
require 'oci/lockbox/models/approver_type'
require 'oci/lockbox/models/change_approval_template_compartment_details'
require 'oci/lockbox/models/change_lockbox_compartment_details'
require 'oci/lockbox/models/create_access_request_details'
require 'oci/lockbox/models/create_approval_template_details'
require 'oci/lockbox/models/create_lockbox_details'
require 'oci/lockbox/models/export_access_requests_details'
require 'oci/lockbox/models/handle_access_request_details'
require 'oci/lockbox/models/lockbox'
require 'oci/lockbox/models/lockbox_auto_approval_state'
require 'oci/lockbox/models/lockbox_collection'
require 'oci/lockbox/models/lockbox_partner'
require 'oci/lockbox/models/lockbox_summary'
require 'oci/lockbox/models/operation_status'
require 'oci/lockbox/models/operation_type'
require 'oci/lockbox/models/persona_level'
require 'oci/lockbox/models/sort_order'
require 'oci/lockbox/models/update_approval_template_details'
require 'oci/lockbox/models/update_lockbox_details'
require 'oci/lockbox/models/work_request'
require 'oci/lockbox/models/work_request_error'
require 'oci/lockbox/models/work_request_error_collection'
require 'oci/lockbox/models/work_request_log_entry'
require 'oci/lockbox/models/work_request_log_entry_collection'
require 'oci/lockbox/models/work_request_resource'
require 'oci/lockbox/models/work_request_resource_metadata_key'
require 'oci/lockbox/models/work_request_summary'
require 'oci/lockbox/models/work_request_summary_collection'

# Require generated clients
require 'oci/lockbox/lockbox_client'
require 'oci/lockbox/lockbox_client_composite_operations'

# Require service utilities
require 'oci/lockbox/util'
