# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220901

module OCI
  module MarketplacePublisher
    # Module containing models for requests made to, and responses received from,
    # OCI MarketplacePublisher services
    module Models
    end
  end
end

# Require models
require 'oci/marketplace_publisher/models/action_type'
require 'oci/marketplace_publisher/models/artifact'
require 'oci/marketplace_publisher/models/artifact_collection'
require 'oci/marketplace_publisher/models/artifact_summary'
require 'oci/marketplace_publisher/models/artifact_type_enum'
require 'oci/marketplace_publisher/models/category'
require 'oci/marketplace_publisher/models/category_collection'
require 'oci/marketplace_publisher/models/category_summary'
require 'oci/marketplace_publisher/models/change_artifact_compartment_details'
require 'oci/marketplace_publisher/models/change_listing_compartment_details'
require 'oci/marketplace_publisher/models/change_term_compartment_details'
require 'oci/marketplace_publisher/models/container_image_artifact'
require 'oci/marketplace_publisher/models/container_image_details'
require 'oci/marketplace_publisher/models/container_package'
require 'oci/marketplace_publisher/models/create_artifact_details'
require 'oci/marketplace_publisher/models/create_container_image_artifact_details'
require 'oci/marketplace_publisher/models/create_container_image_details'
require 'oci/marketplace_publisher/models/create_helm_chart_image_details'
require 'oci/marketplace_publisher/models/create_kubernetes_image_artifact_details'
require 'oci/marketplace_publisher/models/create_listing_details'
require 'oci/marketplace_publisher/models/create_listing_revision_attachment_details'
require 'oci/marketplace_publisher/models/create_listing_revision_details'
require 'oci/marketplace_publisher/models/create_listing_revision_note_details'
require 'oci/marketplace_publisher/models/create_listing_revision_package_details'
require 'oci/marketplace_publisher/models/create_related_document_attachment_details'
require 'oci/marketplace_publisher/models/create_screen_shot_attachment_details'
require 'oci/marketplace_publisher/models/create_term_details'
require 'oci/marketplace_publisher/models/create_video_attachment_details'
require 'oci/marketplace_publisher/models/create_video_details'
require 'oci/marketplace_publisher/models/helm_chart_image_details'
require 'oci/marketplace_publisher/models/helm_chart_package'
require 'oci/marketplace_publisher/models/kubernetes_image_artifact'
require 'oci/marketplace_publisher/models/language_item'
require 'oci/marketplace_publisher/models/listing'
require 'oci/marketplace_publisher/models/listing_collection'
require 'oci/marketplace_publisher/models/listing_revision'
require 'oci/marketplace_publisher/models/listing_revision_attachment'
require 'oci/marketplace_publisher/models/listing_revision_attachment_collection'
require 'oci/marketplace_publisher/models/listing_revision_attachment_summary'
require 'oci/marketplace_publisher/models/listing_revision_collection'
require 'oci/marketplace_publisher/models/listing_revision_icon_attachment'
require 'oci/marketplace_publisher/models/listing_revision_note'
require 'oci/marketplace_publisher/models/listing_revision_note_collection'
require 'oci/marketplace_publisher/models/listing_revision_note_summary'
require 'oci/marketplace_publisher/models/listing_revision_package'
require 'oci/marketplace_publisher/models/listing_revision_package_collection'
require 'oci/marketplace_publisher/models/listing_revision_package_summary'
require 'oci/marketplace_publisher/models/listing_revision_summary'
require 'oci/marketplace_publisher/models/listing_summary'
require 'oci/marketplace_publisher/models/listing_type'
require 'oci/marketplace_publisher/models/market'
require 'oci/marketplace_publisher/models/market_collection'
require 'oci/marketplace_publisher/models/market_summary'
require 'oci/marketplace_publisher/models/named_link'
require 'oci/marketplace_publisher/models/operation_status'
require 'oci/marketplace_publisher/models/operation_type'
require 'oci/marketplace_publisher/models/opn_membership'
require 'oci/marketplace_publisher/models/package_type'
require 'oci/marketplace_publisher/models/private_offer_account_details'
require 'oci/marketplace_publisher/models/product'
require 'oci/marketplace_publisher/models/product_collection'
require 'oci/marketplace_publisher/models/product_summary'
require 'oci/marketplace_publisher/models/publication_status'
require 'oci/marketplace_publisher/models/publish_listing_revision_as_private_details'
require 'oci/marketplace_publisher/models/publisher'
require 'oci/marketplace_publisher/models/publisher_collection'
require 'oci/marketplace_publisher/models/publisher_summary'
require 'oci/marketplace_publisher/models/related_document_attachment'
require 'oci/marketplace_publisher/models/screen_shot_attachment'
require 'oci/marketplace_publisher/models/sort_order'
require 'oci/marketplace_publisher/models/submit_listing_revision_for_review_details'
require 'oci/marketplace_publisher/models/support_contact'
require 'oci/marketplace_publisher/models/term'
require 'oci/marketplace_publisher/models/term_collection'
require 'oci/marketplace_publisher/models/term_summary'
require 'oci/marketplace_publisher/models/term_version'
require 'oci/marketplace_publisher/models/term_version_attachment'
require 'oci/marketplace_publisher/models/term_version_collection'
require 'oci/marketplace_publisher/models/term_version_summary'
require 'oci/marketplace_publisher/models/update_artifact_details'
require 'oci/marketplace_publisher/models/update_container_image_artifact_details'
require 'oci/marketplace_publisher/models/update_container_image_details'
require 'oci/marketplace_publisher/models/update_helm_chart_image_details'
require 'oci/marketplace_publisher/models/update_kubernetes_image_artifact_details'
require 'oci/marketplace_publisher/models/update_listing_details'
require 'oci/marketplace_publisher/models/update_listing_revision_attachment_details'
require 'oci/marketplace_publisher/models/update_listing_revision_details'
require 'oci/marketplace_publisher/models/update_listing_revision_package_details'
require 'oci/marketplace_publisher/models/update_related_document_attachment_details'
require 'oci/marketplace_publisher/models/update_screen_shot_attachment_details'
require 'oci/marketplace_publisher/models/update_term_details'
require 'oci/marketplace_publisher/models/update_term_version_details'
require 'oci/marketplace_publisher/models/update_video_attachment_details'
require 'oci/marketplace_publisher/models/upload_data'
require 'oci/marketplace_publisher/models/validation_status'
require 'oci/marketplace_publisher/models/version_details'
require 'oci/marketplace_publisher/models/video_attachment'
require 'oci/marketplace_publisher/models/work_request'
require 'oci/marketplace_publisher/models/work_request_error'
require 'oci/marketplace_publisher/models/work_request_error_collection'
require 'oci/marketplace_publisher/models/work_request_log_entry'
require 'oci/marketplace_publisher/models/work_request_log_entry_collection'
require 'oci/marketplace_publisher/models/work_request_resource'
require 'oci/marketplace_publisher/models/work_request_resource_metadata_key'
require 'oci/marketplace_publisher/models/work_request_summary'
require 'oci/marketplace_publisher/models/work_request_summary_collection'

# Require generated clients
require 'oci/marketplace_publisher/marketplace_publisher_client'
require 'oci/marketplace_publisher/marketplace_publisher_client_composite_operations'

# Require service utilities
require 'oci/marketplace_publisher/util'
