# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200630
require 'date'
require_relative 'database_insight_summary'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Summary of a database insight resource.
  class Opsi::Models::AutonomousDatabaseInsightSummary < Opsi::Models::DatabaseInsightSummary
    # OCI database resource type
    # @return [String]
    attr_accessor :database_resource_type

    # Flag is to identify if advanced features for autonomous database is enabled or not
    # @return [BOOLEAN]
    attr_accessor :is_advanced_features_enabled

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'id',
        'database_id': :'databaseId',
        'compartment_id': :'compartmentId',
        'database_name': :'databaseName',
        'database_display_name': :'databaseDisplayName',
        'database_type': :'databaseType',
        'database_version': :'databaseVersion',
        'database_host_names': :'databaseHostNames',
        'freeform_tags': :'freeformTags',
        'defined_tags': :'definedTags',
        'system_tags': :'systemTags',
        'entity_source': :'entitySource',
        'processor_count': :'processorCount',
        'status': :'status',
        'time_created': :'timeCreated',
        'time_updated': :'timeUpdated',
        'lifecycle_state': :'lifecycleState',
        'lifecycle_details': :'lifecycleDetails',
        'database_connection_status_details': :'databaseConnectionStatusDetails',
        'database_resource_type': :'databaseResourceType',
        'is_advanced_features_enabled': :'isAdvancedFeaturesEnabled'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'String',
        'database_id': :'String',
        'compartment_id': :'String',
        'database_name': :'String',
        'database_display_name': :'String',
        'database_type': :'String',
        'database_version': :'String',
        'database_host_names': :'Array<String>',
        'freeform_tags': :'Hash<String, String>',
        'defined_tags': :'Hash<String, Hash<String, Object>>',
        'system_tags': :'Hash<String, Hash<String, Object>>',
        'entity_source': :'String',
        'processor_count': :'Integer',
        'status': :'String',
        'time_created': :'DateTime',
        'time_updated': :'DateTime',
        'lifecycle_state': :'String',
        'lifecycle_details': :'String',
        'database_connection_status_details': :'String',
        'database_resource_type': :'String',
        'is_advanced_features_enabled': :'BOOLEAN'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :id The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#id #id} proprety
    # @option attributes [String] :database_id The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#database_id #database_id} proprety
    # @option attributes [String] :compartment_id The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#compartment_id #compartment_id} proprety
    # @option attributes [String] :database_name The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#database_name #database_name} proprety
    # @option attributes [String] :database_display_name The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#database_display_name #database_display_name} proprety
    # @option attributes [String] :database_type The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#database_type #database_type} proprety
    # @option attributes [String] :database_version The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#database_version #database_version} proprety
    # @option attributes [Array<String>] :database_host_names The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#database_host_names #database_host_names} proprety
    # @option attributes [Hash<String, String>] :freeform_tags The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#freeform_tags #freeform_tags} proprety
    # @option attributes [Hash<String, Hash<String, Object>>] :defined_tags The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#defined_tags #defined_tags} proprety
    # @option attributes [Hash<String, Hash<String, Object>>] :system_tags The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#system_tags #system_tags} proprety
    # @option attributes [Integer] :processor_count The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#processor_count #processor_count} proprety
    # @option attributes [String] :status The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#status #status} proprety
    # @option attributes [DateTime] :time_created The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#time_created #time_created} proprety
    # @option attributes [DateTime] :time_updated The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#time_updated #time_updated} proprety
    # @option attributes [String] :lifecycle_state The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#lifecycle_state #lifecycle_state} proprety
    # @option attributes [String] :lifecycle_details The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#lifecycle_details #lifecycle_details} proprety
    # @option attributes [String] :database_connection_status_details The value to assign to the {OCI::Opsi::Models::DatabaseInsightSummary#database_connection_status_details #database_connection_status_details} proprety
    # @option attributes [String] :database_resource_type The value to assign to the {#database_resource_type} property
    # @option attributes [BOOLEAN] :is_advanced_features_enabled The value to assign to the {#is_advanced_features_enabled} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      attributes['entitySource'] = 'AUTONOMOUS_DATABASE'

      super(attributes)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.database_resource_type = attributes[:'databaseResourceType'] if attributes[:'databaseResourceType']

      raise 'You cannot provide both :databaseResourceType and :database_resource_type' if attributes.key?(:'databaseResourceType') && attributes.key?(:'database_resource_type')

      self.database_resource_type = attributes[:'database_resource_type'] if attributes[:'database_resource_type']

      self.is_advanced_features_enabled = attributes[:'isAdvancedFeaturesEnabled'] unless attributes[:'isAdvancedFeaturesEnabled'].nil?
      self.is_advanced_features_enabled = false if is_advanced_features_enabled.nil? && !attributes.key?(:'isAdvancedFeaturesEnabled') # rubocop:disable Style/StringLiterals

      raise 'You cannot provide both :isAdvancedFeaturesEnabled and :is_advanced_features_enabled' if attributes.key?(:'isAdvancedFeaturesEnabled') && attributes.key?(:'is_advanced_features_enabled')

      self.is_advanced_features_enabled = attributes[:'is_advanced_features_enabled'] unless attributes[:'is_advanced_features_enabled'].nil?
      self.is_advanced_features_enabled = false if is_advanced_features_enabled.nil? && !attributes.key?(:'isAdvancedFeaturesEnabled') && !attributes.key?(:'is_advanced_features_enabled') # rubocop:disable Style/StringLiterals
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        id == other.id &&
        database_id == other.database_id &&
        compartment_id == other.compartment_id &&
        database_name == other.database_name &&
        database_display_name == other.database_display_name &&
        database_type == other.database_type &&
        database_version == other.database_version &&
        database_host_names == other.database_host_names &&
        freeform_tags == other.freeform_tags &&
        defined_tags == other.defined_tags &&
        system_tags == other.system_tags &&
        entity_source == other.entity_source &&
        processor_count == other.processor_count &&
        status == other.status &&
        time_created == other.time_created &&
        time_updated == other.time_updated &&
        lifecycle_state == other.lifecycle_state &&
        lifecycle_details == other.lifecycle_details &&
        database_connection_status_details == other.database_connection_status_details &&
        database_resource_type == other.database_resource_type &&
        is_advanced_features_enabled == other.is_advanced_features_enabled
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, database_id, compartment_id, database_name, database_display_name, database_type, database_version, database_host_names, freeform_tags, defined_tags, system_tags, entity_source, processor_count, status, time_created, time_updated, lifecycle_state, lifecycle_details, database_connection_status_details, database_resource_type, is_advanced_features_enabled].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
