# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200630
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Aggregated data per disk.
  class Opsi::Models::DiskStatistics
    # **[Required]** Name of the disk.
    # @return [String]
    attr_accessor :disk_name

    # **[Required]** Value for unallocated space in a disk.
    # @return [Float]
    attr_accessor :disk_unallocated_in_gbs

    # **[Required]** Disk usage.
    # @return [Float]
    attr_accessor :disk_usage_in_gbs

    # **[Required]** Size of the disk.
    # @return [Float]
    attr_accessor :disk_size_in_gbs

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'disk_name': :'diskName',
        'disk_unallocated_in_gbs': :'diskUnallocatedInGBs',
        'disk_usage_in_gbs': :'diskUsageInGBs',
        'disk_size_in_gbs': :'diskSizeInGBs'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'disk_name': :'String',
        'disk_unallocated_in_gbs': :'Float',
        'disk_usage_in_gbs': :'Float',
        'disk_size_in_gbs': :'Float'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :disk_name The value to assign to the {#disk_name} property
    # @option attributes [Float] :disk_unallocated_in_gbs The value to assign to the {#disk_unallocated_in_gbs} property
    # @option attributes [Float] :disk_usage_in_gbs The value to assign to the {#disk_usage_in_gbs} property
    # @option attributes [Float] :disk_size_in_gbs The value to assign to the {#disk_size_in_gbs} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.disk_name = attributes[:'diskName'] if attributes[:'diskName']

      raise 'You cannot provide both :diskName and :disk_name' if attributes.key?(:'diskName') && attributes.key?(:'disk_name')

      self.disk_name = attributes[:'disk_name'] if attributes[:'disk_name']

      self.disk_unallocated_in_gbs = attributes[:'diskUnallocatedInGBs'] if attributes[:'diskUnallocatedInGBs']

      raise 'You cannot provide both :diskUnallocatedInGBs and :disk_unallocated_in_gbs' if attributes.key?(:'diskUnallocatedInGBs') && attributes.key?(:'disk_unallocated_in_gbs')

      self.disk_unallocated_in_gbs = attributes[:'disk_unallocated_in_gbs'] if attributes[:'disk_unallocated_in_gbs']

      self.disk_usage_in_gbs = attributes[:'diskUsageInGBs'] if attributes[:'diskUsageInGBs']

      raise 'You cannot provide both :diskUsageInGBs and :disk_usage_in_gbs' if attributes.key?(:'diskUsageInGBs') && attributes.key?(:'disk_usage_in_gbs')

      self.disk_usage_in_gbs = attributes[:'disk_usage_in_gbs'] if attributes[:'disk_usage_in_gbs']

      self.disk_size_in_gbs = attributes[:'diskSizeInGBs'] if attributes[:'diskSizeInGBs']

      raise 'You cannot provide both :diskSizeInGBs and :disk_size_in_gbs' if attributes.key?(:'diskSizeInGBs') && attributes.key?(:'disk_size_in_gbs')

      self.disk_size_in_gbs = attributes[:'disk_size_in_gbs'] if attributes[:'disk_size_in_gbs']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        disk_name == other.disk_name &&
        disk_unallocated_in_gbs == other.disk_unallocated_in_gbs &&
        disk_usage_in_gbs == other.disk_usage_in_gbs &&
        disk_size_in_gbs == other.disk_size_in_gbs
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [disk_name, disk_unallocated_in_gbs, disk_usage_in_gbs, disk_size_in_gbs].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
