# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200630
require 'date'
require_relative 'host_resource_statistics'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Contains network statistics.
  #
  class Opsi::Models::HostNetworkStatistics < Opsi::Models::HostResourceStatistics
    # @return [Float]
    attr_accessor :network_read_in_mbs

    # @return [Float]
    attr_accessor :network_write_in_mbs

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'usage': :'usage',
        'capacity': :'capacity',
        'utilization_percent': :'utilizationPercent',
        'usage_change_percent': :'usageChangePercent',
        'resource_name': :'resourceName',
        'network_read_in_mbs': :'networkReadInMBs',
        'network_write_in_mbs': :'networkWriteInMBs'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'usage': :'Float',
        'capacity': :'Float',
        'utilization_percent': :'Float',
        'usage_change_percent': :'Float',
        'resource_name': :'String',
        'network_read_in_mbs': :'Float',
        'network_write_in_mbs': :'Float'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [Float] :usage The value to assign to the {OCI::Opsi::Models::HostResourceStatistics#usage #usage} proprety
    # @option attributes [Float] :capacity The value to assign to the {OCI::Opsi::Models::HostResourceStatistics#capacity #capacity} proprety
    # @option attributes [Float] :utilization_percent The value to assign to the {OCI::Opsi::Models::HostResourceStatistics#utilization_percent #utilization_percent} proprety
    # @option attributes [Float] :usage_change_percent The value to assign to the {OCI::Opsi::Models::HostResourceStatistics#usage_change_percent #usage_change_percent} proprety
    # @option attributes [Float] :network_read_in_mbs The value to assign to the {#network_read_in_mbs} property
    # @option attributes [Float] :network_write_in_mbs The value to assign to the {#network_write_in_mbs} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      attributes['resourceName'] = 'HOST_NETWORK_STATISTICS'

      super(attributes)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.network_read_in_mbs = attributes[:'networkReadInMBs'] if attributes[:'networkReadInMBs']

      raise 'You cannot provide both :networkReadInMBs and :network_read_in_mbs' if attributes.key?(:'networkReadInMBs') && attributes.key?(:'network_read_in_mbs')

      self.network_read_in_mbs = attributes[:'network_read_in_mbs'] if attributes[:'network_read_in_mbs']

      self.network_write_in_mbs = attributes[:'networkWriteInMBs'] if attributes[:'networkWriteInMBs']

      raise 'You cannot provide both :networkWriteInMBs and :network_write_in_mbs' if attributes.key?(:'networkWriteInMBs') && attributes.key?(:'network_write_in_mbs')

      self.network_write_in_mbs = attributes[:'network_write_in_mbs'] if attributes[:'network_write_in_mbs']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        usage == other.usage &&
        capacity == other.capacity &&
        utilization_percent == other.utilization_percent &&
        usage_change_percent == other.usage_change_percent &&
        resource_name == other.resource_name &&
        network_read_in_mbs == other.network_read_in_mbs &&
        network_write_in_mbs == other.network_write_in_mbs
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [usage, capacity, utilization_percent, usage_change_percent, resource_name, network_read_in_mbs, network_write_in_mbs].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
