# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200630
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Content types that the news report can handle.
  class Opsi::Models::NewsContentTypes
    # Supported resources for capacity planning content type.
    # @return [Array<OCI::Opsi::Models::NewsContentTypesResource>]
    attr_accessor :capacity_planning_resources

    # Supported resources for SQL insights - fleet analysis content type.
    # @return [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>]
    attr_accessor :sql_insights_fleet_analysis_resources

    # Supported resources for SQL insights - plan changes content type.
    # @return [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>]
    attr_accessor :sql_insights_plan_changes_resources

    # Supported resources for SQL insights - top databases content type.
    # @return [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>]
    attr_accessor :sql_insights_top_databases_resources

    # Supported resources for SQL insights - top SQL by insights content type.
    # @return [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>]
    attr_accessor :sql_insights_top_sql_by_insights_resources

    # Supported resources for SQL insights - top SQL content type.
    # @return [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>]
    attr_accessor :sql_insights_top_sql_resources

    # Supported resources for SQL insights - performance degradation content type.
    # @return [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>]
    attr_accessor :sql_insights_performance_degradation_resources

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'capacity_planning_resources': :'capacityPlanningResources',
        'sql_insights_fleet_analysis_resources': :'sqlInsightsFleetAnalysisResources',
        'sql_insights_plan_changes_resources': :'sqlInsightsPlanChangesResources',
        'sql_insights_top_databases_resources': :'sqlInsightsTopDatabasesResources',
        'sql_insights_top_sql_by_insights_resources': :'sqlInsightsTopSqlByInsightsResources',
        'sql_insights_top_sql_resources': :'sqlInsightsTopSqlResources',
        'sql_insights_performance_degradation_resources': :'sqlInsightsPerformanceDegradationResources'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'capacity_planning_resources': :'Array<OCI::Opsi::Models::NewsContentTypesResource>',
        'sql_insights_fleet_analysis_resources': :'Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>',
        'sql_insights_plan_changes_resources': :'Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>',
        'sql_insights_top_databases_resources': :'Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>',
        'sql_insights_top_sql_by_insights_resources': :'Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>',
        'sql_insights_top_sql_resources': :'Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>',
        'sql_insights_performance_degradation_resources': :'Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [Array<OCI::Opsi::Models::NewsContentTypesResource>] :capacity_planning_resources The value to assign to the {#capacity_planning_resources} property
    # @option attributes [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>] :sql_insights_fleet_analysis_resources The value to assign to the {#sql_insights_fleet_analysis_resources} property
    # @option attributes [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>] :sql_insights_plan_changes_resources The value to assign to the {#sql_insights_plan_changes_resources} property
    # @option attributes [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>] :sql_insights_top_databases_resources The value to assign to the {#sql_insights_top_databases_resources} property
    # @option attributes [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>] :sql_insights_top_sql_by_insights_resources The value to assign to the {#sql_insights_top_sql_by_insights_resources} property
    # @option attributes [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>] :sql_insights_top_sql_resources The value to assign to the {#sql_insights_top_sql_resources} property
    # @option attributes [Array<OCI::Opsi::Models::NewsSqlInsightsContentTypesResource>] :sql_insights_performance_degradation_resources The value to assign to the {#sql_insights_performance_degradation_resources} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.capacity_planning_resources = attributes[:'capacityPlanningResources'] if attributes[:'capacityPlanningResources']

      raise 'You cannot provide both :capacityPlanningResources and :capacity_planning_resources' if attributes.key?(:'capacityPlanningResources') && attributes.key?(:'capacity_planning_resources')

      self.capacity_planning_resources = attributes[:'capacity_planning_resources'] if attributes[:'capacity_planning_resources']

      self.sql_insights_fleet_analysis_resources = attributes[:'sqlInsightsFleetAnalysisResources'] if attributes[:'sqlInsightsFleetAnalysisResources']

      raise 'You cannot provide both :sqlInsightsFleetAnalysisResources and :sql_insights_fleet_analysis_resources' if attributes.key?(:'sqlInsightsFleetAnalysisResources') && attributes.key?(:'sql_insights_fleet_analysis_resources')

      self.sql_insights_fleet_analysis_resources = attributes[:'sql_insights_fleet_analysis_resources'] if attributes[:'sql_insights_fleet_analysis_resources']

      self.sql_insights_plan_changes_resources = attributes[:'sqlInsightsPlanChangesResources'] if attributes[:'sqlInsightsPlanChangesResources']

      raise 'You cannot provide both :sqlInsightsPlanChangesResources and :sql_insights_plan_changes_resources' if attributes.key?(:'sqlInsightsPlanChangesResources') && attributes.key?(:'sql_insights_plan_changes_resources')

      self.sql_insights_plan_changes_resources = attributes[:'sql_insights_plan_changes_resources'] if attributes[:'sql_insights_plan_changes_resources']

      self.sql_insights_top_databases_resources = attributes[:'sqlInsightsTopDatabasesResources'] if attributes[:'sqlInsightsTopDatabasesResources']

      raise 'You cannot provide both :sqlInsightsTopDatabasesResources and :sql_insights_top_databases_resources' if attributes.key?(:'sqlInsightsTopDatabasesResources') && attributes.key?(:'sql_insights_top_databases_resources')

      self.sql_insights_top_databases_resources = attributes[:'sql_insights_top_databases_resources'] if attributes[:'sql_insights_top_databases_resources']

      self.sql_insights_top_sql_by_insights_resources = attributes[:'sqlInsightsTopSqlByInsightsResources'] if attributes[:'sqlInsightsTopSqlByInsightsResources']

      raise 'You cannot provide both :sqlInsightsTopSqlByInsightsResources and :sql_insights_top_sql_by_insights_resources' if attributes.key?(:'sqlInsightsTopSqlByInsightsResources') && attributes.key?(:'sql_insights_top_sql_by_insights_resources')

      self.sql_insights_top_sql_by_insights_resources = attributes[:'sql_insights_top_sql_by_insights_resources'] if attributes[:'sql_insights_top_sql_by_insights_resources']

      self.sql_insights_top_sql_resources = attributes[:'sqlInsightsTopSqlResources'] if attributes[:'sqlInsightsTopSqlResources']

      raise 'You cannot provide both :sqlInsightsTopSqlResources and :sql_insights_top_sql_resources' if attributes.key?(:'sqlInsightsTopSqlResources') && attributes.key?(:'sql_insights_top_sql_resources')

      self.sql_insights_top_sql_resources = attributes[:'sql_insights_top_sql_resources'] if attributes[:'sql_insights_top_sql_resources']

      self.sql_insights_performance_degradation_resources = attributes[:'sqlInsightsPerformanceDegradationResources'] if attributes[:'sqlInsightsPerformanceDegradationResources']

      raise 'You cannot provide both :sqlInsightsPerformanceDegradationResources and :sql_insights_performance_degradation_resources' if attributes.key?(:'sqlInsightsPerformanceDegradationResources') && attributes.key?(:'sql_insights_performance_degradation_resources')

      self.sql_insights_performance_degradation_resources = attributes[:'sql_insights_performance_degradation_resources'] if attributes[:'sql_insights_performance_degradation_resources']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        capacity_planning_resources == other.capacity_planning_resources &&
        sql_insights_fleet_analysis_resources == other.sql_insights_fleet_analysis_resources &&
        sql_insights_plan_changes_resources == other.sql_insights_plan_changes_resources &&
        sql_insights_top_databases_resources == other.sql_insights_top_databases_resources &&
        sql_insights_top_sql_by_insights_resources == other.sql_insights_top_sql_by_insights_resources &&
        sql_insights_top_sql_resources == other.sql_insights_top_sql_resources &&
        sql_insights_performance_degradation_resources == other.sql_insights_performance_degradation_resources
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [capacity_planning_resources, sql_insights_fleet_analysis_resources, sql_insights_plan_changes_resources, sql_insights_top_databases_resources, sql_insights_top_sql_by_insights_resources, sql_insights_top_sql_resources, sql_insights_performance_degradation_resources].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
