# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220901
require 'date'
require_relative 'profile'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Provides the information for a lifecycle environment registration profile.
  class OsManagementHub::Models::LifecycleProfile < OsManagementHub::Models::Profile
    # @return [OCI::OsManagementHub::Models::LifecycleEnvironmentDetails]
    attr_accessor :lifecycle_environment

    # This attribute is required.
    # @return [OCI::OsManagementHub::Models::LifecycleStageDetails]
    attr_accessor :lifecycle_stage

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'id',
        'compartment_id': :'compartmentId',
        'display_name': :'displayName',
        'description': :'description',
        'management_station_id': :'managementStationId',
        'profile_type': :'profileType',
        'vendor_name': :'vendorName',
        'os_family': :'osFamily',
        'arch_type': :'archType',
        'time_created': :'timeCreated',
        'lifecycle_state': :'lifecycleState',
        'registration_type': :'registrationType',
        'is_default_profile': :'isDefaultProfile',
        'is_service_provided_profile': :'isServiceProvidedProfile',
        'freeform_tags': :'freeformTags',
        'defined_tags': :'definedTags',
        'system_tags': :'systemTags',
        'lifecycle_environment': :'lifecycleEnvironment',
        'lifecycle_stage': :'lifecycleStage'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'String',
        'compartment_id': :'String',
        'display_name': :'String',
        'description': :'String',
        'management_station_id': :'String',
        'profile_type': :'String',
        'vendor_name': :'String',
        'os_family': :'String',
        'arch_type': :'String',
        'time_created': :'DateTime',
        'lifecycle_state': :'String',
        'registration_type': :'String',
        'is_default_profile': :'BOOLEAN',
        'is_service_provided_profile': :'BOOLEAN',
        'freeform_tags': :'Hash<String, String>',
        'defined_tags': :'Hash<String, Hash<String, Object>>',
        'system_tags': :'Hash<String, Hash<String, Object>>',
        'lifecycle_environment': :'OCI::OsManagementHub::Models::LifecycleEnvironmentDetails',
        'lifecycle_stage': :'OCI::OsManagementHub::Models::LifecycleStageDetails'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :id The value to assign to the {OCI::OsManagementHub::Models::Profile#id #id} proprety
    # @option attributes [String] :compartment_id The value to assign to the {OCI::OsManagementHub::Models::Profile#compartment_id #compartment_id} proprety
    # @option attributes [String] :display_name The value to assign to the {OCI::OsManagementHub::Models::Profile#display_name #display_name} proprety
    # @option attributes [String] :description The value to assign to the {OCI::OsManagementHub::Models::Profile#description #description} proprety
    # @option attributes [String] :management_station_id The value to assign to the {OCI::OsManagementHub::Models::Profile#management_station_id #management_station_id} proprety
    # @option attributes [String] :vendor_name The value to assign to the {OCI::OsManagementHub::Models::Profile#vendor_name #vendor_name} proprety
    # @option attributes [String] :os_family The value to assign to the {OCI::OsManagementHub::Models::Profile#os_family #os_family} proprety
    # @option attributes [String] :arch_type The value to assign to the {OCI::OsManagementHub::Models::Profile#arch_type #arch_type} proprety
    # @option attributes [DateTime] :time_created The value to assign to the {OCI::OsManagementHub::Models::Profile#time_created #time_created} proprety
    # @option attributes [String] :lifecycle_state The value to assign to the {OCI::OsManagementHub::Models::Profile#lifecycle_state #lifecycle_state} proprety
    # @option attributes [String] :registration_type The value to assign to the {OCI::OsManagementHub::Models::Profile#registration_type #registration_type} proprety
    # @option attributes [BOOLEAN] :is_default_profile The value to assign to the {OCI::OsManagementHub::Models::Profile#is_default_profile #is_default_profile} proprety
    # @option attributes [BOOLEAN] :is_service_provided_profile The value to assign to the {OCI::OsManagementHub::Models::Profile#is_service_provided_profile #is_service_provided_profile} proprety
    # @option attributes [Hash<String, String>] :freeform_tags The value to assign to the {OCI::OsManagementHub::Models::Profile#freeform_tags #freeform_tags} proprety
    # @option attributes [Hash<String, Hash<String, Object>>] :defined_tags The value to assign to the {OCI::OsManagementHub::Models::Profile#defined_tags #defined_tags} proprety
    # @option attributes [Hash<String, Hash<String, Object>>] :system_tags The value to assign to the {OCI::OsManagementHub::Models::Profile#system_tags #system_tags} proprety
    # @option attributes [OCI::OsManagementHub::Models::LifecycleEnvironmentDetails] :lifecycle_environment The value to assign to the {#lifecycle_environment} property
    # @option attributes [OCI::OsManagementHub::Models::LifecycleStageDetails] :lifecycle_stage The value to assign to the {#lifecycle_stage} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      attributes['profileType'] = 'LIFECYCLE'

      super(attributes)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.lifecycle_environment = attributes[:'lifecycleEnvironment'] if attributes[:'lifecycleEnvironment']

      raise 'You cannot provide both :lifecycleEnvironment and :lifecycle_environment' if attributes.key?(:'lifecycleEnvironment') && attributes.key?(:'lifecycle_environment')

      self.lifecycle_environment = attributes[:'lifecycle_environment'] if attributes[:'lifecycle_environment']

      self.lifecycle_stage = attributes[:'lifecycleStage'] if attributes[:'lifecycleStage']

      raise 'You cannot provide both :lifecycleStage and :lifecycle_stage' if attributes.key?(:'lifecycleStage') && attributes.key?(:'lifecycle_stage')

      self.lifecycle_stage = attributes[:'lifecycle_stage'] if attributes[:'lifecycle_stage']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        id == other.id &&
        compartment_id == other.compartment_id &&
        display_name == other.display_name &&
        description == other.description &&
        management_station_id == other.management_station_id &&
        profile_type == other.profile_type &&
        vendor_name == other.vendor_name &&
        os_family == other.os_family &&
        arch_type == other.arch_type &&
        time_created == other.time_created &&
        lifecycle_state == other.lifecycle_state &&
        registration_type == other.registration_type &&
        is_default_profile == other.is_default_profile &&
        is_service_provided_profile == other.is_service_provided_profile &&
        freeform_tags == other.freeform_tags &&
        defined_tags == other.defined_tags &&
        system_tags == other.system_tags &&
        lifecycle_environment == other.lifecycle_environment &&
        lifecycle_stage == other.lifecycle_stage
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, compartment_id, display_name, description, management_station_id, profile_type, vendor_name, os_family, arch_type, time_created, lifecycle_state, registration_type, is_default_profile, is_service_provided_profile, freeform_tags, defined_tags, system_tags, lifecycle_environment, lifecycle_stage].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
