# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20191001

module OCI
  module OspGateway
    # Module containing models for requests made to, and responses received from,
    # OCI OspGateway services
    module Models
    end
  end
end

# Require models
require 'oci/osp_gateway/models/address'
require 'oci/osp_gateway/models/address_quality_type'
require 'oci/osp_gateway/models/address_rule'
require 'oci/osp_gateway/models/address_type_rule'
require 'oci/osp_gateway/models/address_verification_code'
require 'oci/osp_gateway/models/authorize_subscription_payment_details'
require 'oci/osp_gateway/models/authorize_subscription_payment_receipt'
require 'oci/osp_gateway/models/bill_to_address'
require 'oci/osp_gateway/models/contact_type_rule'
require 'oci/osp_gateway/models/country'
require 'oci/osp_gateway/models/credit_card_payment_detail'
require 'oci/osp_gateway/models/credit_card_payment_option'
require 'oci/osp_gateway/models/credit_card_type'
require 'oci/osp_gateway/models/currency'
require 'oci/osp_gateway/models/echeck_payment_detail'
require 'oci/osp_gateway/models/field'
require 'oci/osp_gateway/models/format'
require 'oci/osp_gateway/models/invoice'
require 'oci/osp_gateway/models/invoice_collection'
require 'oci/osp_gateway/models/invoice_line_collection'
require 'oci/osp_gateway/models/invoice_line_summary'
require 'oci/osp_gateway/models/invoice_summary'
require 'oci/osp_gateway/models/label'
require 'oci/osp_gateway/models/merchant_defined_data'
require 'oci/osp_gateway/models/other_payment_detail'
require 'oci/osp_gateway/models/pay_invoice_details'
require 'oci/osp_gateway/models/pay_invoice_receipt'
require 'oci/osp_gateway/models/pay_subscription_details'
require 'oci/osp_gateway/models/pay_subscription_receipt'
require 'oci/osp_gateway/models/payment_detail'
require 'oci/osp_gateway/models/payment_gateway'
require 'oci/osp_gateway/models/payment_method'
require 'oci/osp_gateway/models/payment_option'
require 'oci/osp_gateway/models/paypal_payment_detail'
require 'oci/osp_gateway/models/paypal_payment_option'
require 'oci/osp_gateway/models/subscription'
require 'oci/osp_gateway/models/subscription_collection'
require 'oci/osp_gateway/models/subscription_summary'
require 'oci/osp_gateway/models/tax_info'
require 'oci/osp_gateway/models/tax_type_rule'
require 'oci/osp_gateway/models/third_party_validation_type'
require 'oci/osp_gateway/models/update_subscription_details'
require 'oci/osp_gateway/models/value_set_entity'
require 'oci/osp_gateway/models/verify_address_details'
require 'oci/osp_gateway/models/verify_address_receipt'

# Require generated clients
require 'oci/osp_gateway/address_rule_service_client'
require 'oci/osp_gateway/address_service_client'
require 'oci/osp_gateway/invoice_service_client'
require 'oci/osp_gateway/subscription_service_client'

# Require service utilities
require 'oci/osp_gateway/util'
