# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20180917

module OCI
  module ResourceManager
    # Module containing models for requests made to, and responses received from,
    # OCI ResourceManager services
    module Models
    end
  end
end

# Require models
require 'oci/resource_manager/models/apply_job_operation_details'
require 'oci/resource_manager/models/apply_job_operation_details_summary'
require 'oci/resource_manager/models/apply_job_plan_resolution'
require 'oci/resource_manager/models/apply_rollback_job_operation_details'
require 'oci/resource_manager/models/apply_rollback_job_operation_details_summary'
require 'oci/resource_manager/models/associated_resource_summary'
require 'oci/resource_manager/models/associated_resources_collection'
require 'oci/resource_manager/models/bitbucket_cloud_config_source'
require 'oci/resource_manager/models/bitbucket_cloud_config_source_record'
require 'oci/resource_manager/models/bitbucket_cloud_username_app_password_configuration_source_provider'
require 'oci/resource_manager/models/bitbucket_cloud_username_app_password_configuration_source_provider_summary'
require 'oci/resource_manager/models/bitbucket_server_access_token_configuration_source_provider'
require 'oci/resource_manager/models/bitbucket_server_access_token_configuration_source_provider_summary'
require 'oci/resource_manager/models/bitbucket_server_config_source'
require 'oci/resource_manager/models/bitbucket_server_config_source_record'
require 'oci/resource_manager/models/cancellation_details'
require 'oci/resource_manager/models/change_configuration_source_provider_compartment_details'
require 'oci/resource_manager/models/change_private_endpoint_compartment_details'
require 'oci/resource_manager/models/change_stack_compartment_details'
require 'oci/resource_manager/models/change_template_compartment_details'
require 'oci/resource_manager/models/compartment_config_source'
require 'oci/resource_manager/models/config_source'
require 'oci/resource_manager/models/config_source_record'
require 'oci/resource_manager/models/configuration_source_provider'
require 'oci/resource_manager/models/configuration_source_provider_collection'
require 'oci/resource_manager/models/configuration_source_provider_summary'
require 'oci/resource_manager/models/create_apply_job_operation_details'
require 'oci/resource_manager/models/create_apply_rollback_job_operation_details'
require 'oci/resource_manager/models/create_bitbucket_cloud_config_source_details'
require 'oci/resource_manager/models/create_bitbucket_cloud_username_app_password_configuration_source_provider_details'
require 'oci/resource_manager/models/create_bitbucket_server_access_token_configuration_source_provider_details'
require 'oci/resource_manager/models/create_bitbucket_server_config_source_details'
require 'oci/resource_manager/models/create_compartment_config_source_details'
require 'oci/resource_manager/models/create_config_source_details'
require 'oci/resource_manager/models/create_configuration_source_provider_details'
require 'oci/resource_manager/models/create_destroy_job_operation_details'
require 'oci/resource_manager/models/create_dev_ops_config_source_details'
require 'oci/resource_manager/models/create_git_config_source_details'
require 'oci/resource_manager/models/create_github_access_token_configuration_source_provider_details'
require 'oci/resource_manager/models/create_gitlab_access_token_configuration_source_provider_details'
require 'oci/resource_manager/models/create_import_tf_state_job_operation_details'
require 'oci/resource_manager/models/create_job_details'
require 'oci/resource_manager/models/create_job_operation_details'
require 'oci/resource_manager/models/create_object_storage_config_source_details'
require 'oci/resource_manager/models/create_plan_job_operation_details'
require 'oci/resource_manager/models/create_plan_rollback_job_operation_details'
require 'oci/resource_manager/models/create_private_endpoint_details'
require 'oci/resource_manager/models/create_stack_details'
require 'oci/resource_manager/models/create_stack_template_config_source_details'
require 'oci/resource_manager/models/create_template_config_source_details'
require 'oci/resource_manager/models/create_template_details'
require 'oci/resource_manager/models/create_template_zip_upload_config_source_details'
require 'oci/resource_manager/models/create_zip_upload_config_source_details'
require 'oci/resource_manager/models/custom_terraform_provider'
require 'oci/resource_manager/models/destroy_job_operation_details'
require 'oci/resource_manager/models/destroy_job_operation_details_summary'
require 'oci/resource_manager/models/detect_stack_drift_details'
require 'oci/resource_manager/models/dev_ops_config_source'
require 'oci/resource_manager/models/dev_ops_config_source_record'
require 'oci/resource_manager/models/failure_details'
require 'oci/resource_manager/models/git_config_source'
require 'oci/resource_manager/models/git_config_source_record'
require 'oci/resource_manager/models/github_access_token_configuration_source_provider'
require 'oci/resource_manager/models/github_access_token_configuration_source_provider_summary'
require 'oci/resource_manager/models/gitlab_access_token_configuration_source_provider'
require 'oci/resource_manager/models/gitlab_access_token_configuration_source_provider_summary'
require 'oci/resource_manager/models/import_tf_state_job_operation_details'
require 'oci/resource_manager/models/import_tf_state_job_operation_details_summary'
require 'oci/resource_manager/models/job'
require 'oci/resource_manager/models/job_operation_details'
require 'oci/resource_manager/models/job_operation_details_summary'
require 'oci/resource_manager/models/job_output_summary'
require 'oci/resource_manager/models/job_outputs_collection'
require 'oci/resource_manager/models/job_summary'
require 'oci/resource_manager/models/log_entry'
require 'oci/resource_manager/models/object_storage_config_source'
require 'oci/resource_manager/models/object_storage_config_source_record'
require 'oci/resource_manager/models/plan_job_operation_details'
require 'oci/resource_manager/models/plan_job_operation_details_summary'
require 'oci/resource_manager/models/plan_rollback_job_operation_details'
require 'oci/resource_manager/models/plan_rollback_job_operation_details_summary'
require 'oci/resource_manager/models/private_endpoint'
require 'oci/resource_manager/models/private_endpoint_collection'
require 'oci/resource_manager/models/private_endpoint_summary'
require 'oci/resource_manager/models/private_server_config_details'
require 'oci/resource_manager/models/reachable_ip'
require 'oci/resource_manager/models/resource_discovery_service_collection'
require 'oci/resource_manager/models/resource_discovery_service_summary'
require 'oci/resource_manager/models/stack'
require 'oci/resource_manager/models/stack_resource_drift_collection'
require 'oci/resource_manager/models/stack_resource_drift_summary'
require 'oci/resource_manager/models/stack_summary'
require 'oci/resource_manager/models/template'
require 'oci/resource_manager/models/template_category_summary'
require 'oci/resource_manager/models/template_category_summary_collection'
require 'oci/resource_manager/models/template_config_source'
require 'oci/resource_manager/models/template_summary'
require 'oci/resource_manager/models/template_summary_collection'
require 'oci/resource_manager/models/template_zip_upload_config_source'
require 'oci/resource_manager/models/terraform_advanced_options'
require 'oci/resource_manager/models/terraform_version_collection'
require 'oci/resource_manager/models/terraform_version_summary'
require 'oci/resource_manager/models/update_bitbucket_cloud_config_source_details'
require 'oci/resource_manager/models/update_bitbucket_cloud_username_app_password_configuration_source_provider_details'
require 'oci/resource_manager/models/update_bitbucket_server_access_token_configuration_source_provider_details'
require 'oci/resource_manager/models/update_bitbucket_server_config_source_details'
require 'oci/resource_manager/models/update_config_source_details'
require 'oci/resource_manager/models/update_configuration_source_provider_details'
require 'oci/resource_manager/models/update_dev_ops_config_source_details'
require 'oci/resource_manager/models/update_git_config_source_details'
require 'oci/resource_manager/models/update_github_access_token_configuration_source_provider_details'
require 'oci/resource_manager/models/update_gitlab_access_token_configuration_source_provider_details'
require 'oci/resource_manager/models/update_job_details'
require 'oci/resource_manager/models/update_object_storage_config_source_details'
require 'oci/resource_manager/models/update_private_endpoint_details'
require 'oci/resource_manager/models/update_stack_details'
require 'oci/resource_manager/models/update_template_config_source_details'
require 'oci/resource_manager/models/update_template_details'
require 'oci/resource_manager/models/update_template_zip_upload_config_source_details'
require 'oci/resource_manager/models/update_zip_upload_config_source_details'
require 'oci/resource_manager/models/work_request'
require 'oci/resource_manager/models/work_request_error'
require 'oci/resource_manager/models/work_request_log_entry'
require 'oci/resource_manager/models/work_request_resource'
require 'oci/resource_manager/models/work_request_summary'
require 'oci/resource_manager/models/zip_upload_config_source'
require 'oci/resource_manager/models/zip_upload_config_source_record'

# Require generated clients
require 'oci/resource_manager/resource_manager_client'
require 'oci/resource_manager/resource_manager_client_composite_operations'

# Require service utilities
require 'oci/resource_manager/util'
