# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20230401

module OCI
  module TenantManagerControlPlane
    # Module containing models for requests made to, and responses received from,
    # OCI TenantManagerControlPlane services
    module Models
    end
  end
end

# Require models
require 'oci/tenant_manager_control_plane/models/action_type'
require 'oci/tenant_manager_control_plane/models/activate_order_details'
require 'oci/tenant_manager_control_plane/models/assigned_subscription'
require 'oci/tenant_manager_control_plane/models/assigned_subscription_collection'
require 'oci/tenant_manager_control_plane/models/assigned_subscription_line_item_collection'
require 'oci/tenant_manager_control_plane/models/assigned_subscription_line_item_summary'
require 'oci/tenant_manager_control_plane/models/assigned_subscription_summary'
require 'oci/tenant_manager_control_plane/models/available_region_collection'
require 'oci/tenant_manager_control_plane/models/available_region_summary'
require 'oci/tenant_manager_control_plane/models/billing_model'
require 'oci/tenant_manager_control_plane/models/classic_assigned_subscription'
require 'oci/tenant_manager_control_plane/models/classic_assigned_subscription_summary'
require 'oci/tenant_manager_control_plane/models/classic_subscription'
require 'oci/tenant_manager_control_plane/models/classic_subscription_environment_name'
require 'oci/tenant_manager_control_plane/models/classic_subscription_lifecycle_state'
require 'oci/tenant_manager_control_plane/models/classic_subscription_summary'
require 'oci/tenant_manager_control_plane/models/cloud_assigned_subscription'
require 'oci/tenant_manager_control_plane/models/cloud_assigned_subscription_summary'
require 'oci/tenant_manager_control_plane/models/cloud_subscription'
require 'oci/tenant_manager_control_plane/models/cloud_subscription_summary'
require 'oci/tenant_manager_control_plane/models/create_child_tenancy_details'
require 'oci/tenant_manager_control_plane/models/create_domain_details'
require 'oci/tenant_manager_control_plane/models/create_domain_governance_details'
require 'oci/tenant_manager_control_plane/models/create_sender_invitation_details'
require 'oci/tenant_manager_control_plane/models/create_subscription_mapping_details'
require 'oci/tenant_manager_control_plane/models/domain'
require 'oci/tenant_manager_control_plane/models/domain_collection'
require 'oci/tenant_manager_control_plane/models/domain_governance'
require 'oci/tenant_manager_control_plane/models/domain_governance_collection'
require 'oci/tenant_manager_control_plane/models/domain_governance_summary'
require 'oci/tenant_manager_control_plane/models/domain_summary'
require 'oci/tenant_manager_control_plane/models/entity_version'
require 'oci/tenant_manager_control_plane/models/governance_status'
require 'oci/tenant_manager_control_plane/models/invitation_subject'
require 'oci/tenant_manager_control_plane/models/lifecycle_state'
require 'oci/tenant_manager_control_plane/models/link'
require 'oci/tenant_manager_control_plane/models/link_collection'
require 'oci/tenant_manager_control_plane/models/link_summary'
require 'oci/tenant_manager_control_plane/models/operation_status'
require 'oci/tenant_manager_control_plane/models/operation_type'
require 'oci/tenant_manager_control_plane/models/order'
require 'oci/tenant_manager_control_plane/models/organization'
require 'oci/tenant_manager_control_plane/models/organization_collection'
require 'oci/tenant_manager_control_plane/models/organization_summary'
require 'oci/tenant_manager_control_plane/models/organization_tenancy'
require 'oci/tenant_manager_control_plane/models/organization_tenancy_collection'
require 'oci/tenant_manager_control_plane/models/organization_tenancy_lifecycle_state'
require 'oci/tenant_manager_control_plane/models/organization_tenancy_role'
require 'oci/tenant_manager_control_plane/models/organization_tenancy_summary'
require 'oci/tenant_manager_control_plane/models/promotion'
require 'oci/tenant_manager_control_plane/models/recipient_invitation'
require 'oci/tenant_manager_control_plane/models/recipient_invitation_collection'
require 'oci/tenant_manager_control_plane/models/recipient_invitation_status'
require 'oci/tenant_manager_control_plane/models/recipient_invitation_summary'
require 'oci/tenant_manager_control_plane/models/revive_workflow_instance_details'
require 'oci/tenant_manager_control_plane/models/sender_invitation'
require 'oci/tenant_manager_control_plane/models/sender_invitation_collection'
require 'oci/tenant_manager_control_plane/models/sender_invitation_status'
require 'oci/tenant_manager_control_plane/models/sender_invitation_summary'
require 'oci/tenant_manager_control_plane/models/sku'
require 'oci/tenant_manager_control_plane/models/sort_order'
require 'oci/tenant_manager_control_plane/models/subscription'
require 'oci/tenant_manager_control_plane/models/subscription_collection'
require 'oci/tenant_manager_control_plane/models/subscription_info'
require 'oci/tenant_manager_control_plane/models/subscription_lifecycle_state'
require 'oci/tenant_manager_control_plane/models/subscription_line_item_collection'
require 'oci/tenant_manager_control_plane/models/subscription_line_item_summary'
require 'oci/tenant_manager_control_plane/models/subscription_mapping'
require 'oci/tenant_manager_control_plane/models/subscription_mapping_collection'
require 'oci/tenant_manager_control_plane/models/subscription_mapping_summary'
require 'oci/tenant_manager_control_plane/models/subscription_sku'
require 'oci/tenant_manager_control_plane/models/subscription_summary'
require 'oci/tenant_manager_control_plane/models/update_domain_details'
require 'oci/tenant_manager_control_plane/models/update_domain_governance_details'
require 'oci/tenant_manager_control_plane/models/update_organization_details'
require 'oci/tenant_manager_control_plane/models/update_recipient_invitation_details'
require 'oci/tenant_manager_control_plane/models/update_sender_invitation_details'
require 'oci/tenant_manager_control_plane/models/work_request'
require 'oci/tenant_manager_control_plane/models/work_request_collection'
require 'oci/tenant_manager_control_plane/models/work_request_error'
require 'oci/tenant_manager_control_plane/models/work_request_error_collection'
require 'oci/tenant_manager_control_plane/models/work_request_log_entry'
require 'oci/tenant_manager_control_plane/models/work_request_log_entry_collection'
require 'oci/tenant_manager_control_plane/models/work_request_resource'
require 'oci/tenant_manager_control_plane/models/work_request_summary'

# Require generated clients
require 'oci/tenant_manager_control_plane/domain_client'
require 'oci/tenant_manager_control_plane/domain_client_composite_operations'
require 'oci/tenant_manager_control_plane/domain_governance_client'
require 'oci/tenant_manager_control_plane/domain_governance_client_composite_operations'
require 'oci/tenant_manager_control_plane/governance_client'
require 'oci/tenant_manager_control_plane/governance_client_composite_operations'
require 'oci/tenant_manager_control_plane/link_client'
require 'oci/tenant_manager_control_plane/link_client_composite_operations'
require 'oci/tenant_manager_control_plane/orders_client'
require 'oci/tenant_manager_control_plane/orders_client_composite_operations'
require 'oci/tenant_manager_control_plane/organization_client'
require 'oci/tenant_manager_control_plane/organization_client_composite_operations'
require 'oci/tenant_manager_control_plane/recipient_invitation_client'
require 'oci/tenant_manager_control_plane/recipient_invitation_client_composite_operations'
require 'oci/tenant_manager_control_plane/sender_invitation_client'
require 'oci/tenant_manager_control_plane/sender_invitation_client_composite_operations'
require 'oci/tenant_manager_control_plane/subscription_client'
require 'oci/tenant_manager_control_plane/subscription_client_composite_operations'
require 'oci/tenant_manager_control_plane/work_request_client'

# Require service utilities
require 'oci/tenant_manager_control_plane/util'
