# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210215

module OCI
  module VulnerabilityScanning
    # Module containing models for requests made to, and responses received from,
    # OCI VulnerabilityScanning services
    module Models
    end
  end
end

# Require models
require 'oci/vulnerability_scanning/models/action_type'
require 'oci/vulnerability_scanning/models/application_scan_settings'
require 'oci/vulnerability_scanning/models/change_container_scan_recipe_compartment_details'
require 'oci/vulnerability_scanning/models/change_container_scan_result_compartment_details'
require 'oci/vulnerability_scanning/models/change_container_scan_target_compartment_details'
require 'oci/vulnerability_scanning/models/change_host_agent_scan_result_compartment_details'
require 'oci/vulnerability_scanning/models/change_host_cis_benchmark_scan_result_compartment_details'
require 'oci/vulnerability_scanning/models/change_host_endpoint_protection_scan_result_compartment_details'
require 'oci/vulnerability_scanning/models/change_host_port_scan_result_compartment_details'
require 'oci/vulnerability_scanning/models/change_host_scan_recipe_compartment_details'
require 'oci/vulnerability_scanning/models/change_host_scan_target_compartment_details'
require 'oci/vulnerability_scanning/models/container_scan_recipe'
require 'oci/vulnerability_scanning/models/container_scan_recipe_summary'
require 'oci/vulnerability_scanning/models/container_scan_recipe_summary_collection'
require 'oci/vulnerability_scanning/models/container_scan_registry'
require 'oci/vulnerability_scanning/models/container_scan_result'
require 'oci/vulnerability_scanning/models/container_scan_result_problem'
require 'oci/vulnerability_scanning/models/container_scan_result_sort_by'
require 'oci/vulnerability_scanning/models/container_scan_result_summary'
require 'oci/vulnerability_scanning/models/container_scan_result_summary_collection'
require 'oci/vulnerability_scanning/models/container_scan_settings'
require 'oci/vulnerability_scanning/models/container_scan_target'
require 'oci/vulnerability_scanning/models/container_scan_target_summary'
require 'oci/vulnerability_scanning/models/container_scan_target_summary_collection'
require 'oci/vulnerability_scanning/models/create_container_scan_recipe_details'
require 'oci/vulnerability_scanning/models/create_container_scan_registry_details'
require 'oci/vulnerability_scanning/models/create_container_scan_target_details'
require 'oci/vulnerability_scanning/models/create_host_scan_recipe_details'
require 'oci/vulnerability_scanning/models/create_host_scan_target_details'
require 'oci/vulnerability_scanning/models/create_ocir_container_scan_registry_details'
require 'oci/vulnerability_scanning/models/cve_details'
require 'oci/vulnerability_scanning/models/day_of_week'
require 'oci/vulnerability_scanning/models/export_host_agent_scan_result_csv_details'
require 'oci/vulnerability_scanning/models/export_host_vulnerability_csv_details'
require 'oci/vulnerability_scanning/models/folder_to_scan'
require 'oci/vulnerability_scanning/models/host_agent_scan_level'
require 'oci/vulnerability_scanning/models/host_agent_scan_result'
require 'oci/vulnerability_scanning/models/host_agent_scan_result_problem'
require 'oci/vulnerability_scanning/models/host_agent_scan_result_sort_by'
require 'oci/vulnerability_scanning/models/host_agent_scan_result_summary'
require 'oci/vulnerability_scanning/models/host_agent_scan_result_summary_collection'
require 'oci/vulnerability_scanning/models/host_cis_benchmark_scan_level'
require 'oci/vulnerability_scanning/models/host_cis_benchmark_scan_result'
require 'oci/vulnerability_scanning/models/host_cis_benchmark_scan_result_score'
require 'oci/vulnerability_scanning/models/host_cis_benchmark_scan_result_sort_by'
require 'oci/vulnerability_scanning/models/host_cis_benchmark_scan_result_summary'
require 'oci/vulnerability_scanning/models/host_cis_benchmark_scan_result_summary_collection'
require 'oci/vulnerability_scanning/models/host_cis_benchmark_settings'
require 'oci/vulnerability_scanning/models/host_endpoint_protection_scan_level'
require 'oci/vulnerability_scanning/models/host_endpoint_protection_scan_result'
require 'oci/vulnerability_scanning/models/host_endpoint_protection_scan_result_endpoint_protection'
require 'oci/vulnerability_scanning/models/host_endpoint_protection_scan_result_sort_by'
require 'oci/vulnerability_scanning/models/host_endpoint_protection_scan_result_summary'
require 'oci/vulnerability_scanning/models/host_endpoint_protection_scan_result_summary_collection'
require 'oci/vulnerability_scanning/models/host_endpoint_protection_settings'
require 'oci/vulnerability_scanning/models/host_port_scan_level'
require 'oci/vulnerability_scanning/models/host_port_scan_result'
require 'oci/vulnerability_scanning/models/host_port_scan_result_open_port'
require 'oci/vulnerability_scanning/models/host_port_scan_result_sort_by'
require 'oci/vulnerability_scanning/models/host_port_scan_result_summary'
require 'oci/vulnerability_scanning/models/host_port_scan_result_summary_collection'
require 'oci/vulnerability_scanning/models/host_scan_agent_configuration'
require 'oci/vulnerability_scanning/models/host_scan_agent_configuration_oci'
require 'oci/vulnerability_scanning/models/host_scan_agent_configuration_qualys'
require 'oci/vulnerability_scanning/models/host_scan_agent_settings'
require 'oci/vulnerability_scanning/models/host_scan_port_settings'
require 'oci/vulnerability_scanning/models/host_scan_recipe'
require 'oci/vulnerability_scanning/models/host_scan_recipe_summary'
require 'oci/vulnerability_scanning/models/host_scan_recipe_summary_collection'
require 'oci/vulnerability_scanning/models/host_scan_target'
require 'oci/vulnerability_scanning/models/host_scan_target_error_summary'
require 'oci/vulnerability_scanning/models/host_scan_target_error_summary_collection'
require 'oci/vulnerability_scanning/models/host_scan_target_summary'
require 'oci/vulnerability_scanning/models/host_scan_target_summary_collection'
require 'oci/vulnerability_scanning/models/host_vulnerability'
require 'oci/vulnerability_scanning/models/host_vulnerability_impacted_host_summary'
require 'oci/vulnerability_scanning/models/host_vulnerability_impacted_host_summary_collection'
require 'oci/vulnerability_scanning/models/host_vulnerability_sort_by'
require 'oci/vulnerability_scanning/models/host_vulnerability_summary'
require 'oci/vulnerability_scanning/models/host_vulnerability_summary_collection'
require 'oci/vulnerability_scanning/models/impacted_host_sort_by'
require 'oci/vulnerability_scanning/models/impacted_resources_count'
require 'oci/vulnerability_scanning/models/lifecycle_state'
require 'oci/vulnerability_scanning/models/ocir_container_scan_registry'
require 'oci/vulnerability_scanning/models/operating_system'
require 'oci/vulnerability_scanning/models/operation_status'
require 'oci/vulnerability_scanning/models/operation_type'
require 'oci/vulnerability_scanning/models/package'
require 'oci/vulnerability_scanning/models/scan_result_problem_severity'
require 'oci/vulnerability_scanning/models/scan_result_score'
require 'oci/vulnerability_scanning/models/scan_result_vulnerability_state'
require 'oci/vulnerability_scanning/models/schedule'
require 'oci/vulnerability_scanning/models/schedule_type'
require 'oci/vulnerability_scanning/models/sort_by'
require 'oci/vulnerability_scanning/models/sort_by_time'
require 'oci/vulnerability_scanning/models/sort_order'
require 'oci/vulnerability_scanning/models/update_container_scan_recipe_details'
require 'oci/vulnerability_scanning/models/update_container_scan_registry_details'
require 'oci/vulnerability_scanning/models/update_container_scan_target_details'
require 'oci/vulnerability_scanning/models/update_host_scan_recipe_details'
require 'oci/vulnerability_scanning/models/update_host_scan_target_details'
require 'oci/vulnerability_scanning/models/update_ocir_container_scan_registry_details'
require 'oci/vulnerability_scanning/models/vendor_type'
require 'oci/vulnerability_scanning/models/vulnerability'
require 'oci/vulnerability_scanning/models/vulnerability_impacted_container_summary'
require 'oci/vulnerability_scanning/models/vulnerability_impacted_container_summary_collection'
require 'oci/vulnerability_scanning/models/vulnerability_impacted_host_summary'
require 'oci/vulnerability_scanning/models/vulnerability_impacted_host_summary_collection'
require 'oci/vulnerability_scanning/models/vulnerability_summary'
require 'oci/vulnerability_scanning/models/vulnerability_summary_collection'
require 'oci/vulnerability_scanning/models/vulnerability_type'
require 'oci/vulnerability_scanning/models/work_request'
require 'oci/vulnerability_scanning/models/work_request_collection'
require 'oci/vulnerability_scanning/models/work_request_error'
require 'oci/vulnerability_scanning/models/work_request_error_collection'
require 'oci/vulnerability_scanning/models/work_request_log_entry'
require 'oci/vulnerability_scanning/models/work_request_log_entry_collection'
require 'oci/vulnerability_scanning/models/work_request_resource'

# Require generated clients
require 'oci/vulnerability_scanning/vulnerability_scanning_client'
require 'oci/vulnerability_scanning/vulnerability_scanning_client_composite_operations'

# Require service utilities
require 'oci/vulnerability_scanning/util'
